#include "grader.h"
#include <algorithm>
#include <string>
#include <vector>
#define mp make_pair
#define fs first
#define sc second

using namespace std;
const int MAXN = 1000001;

int n;


int p0[MAXN], r0[MAXN], c0[MAXN];
int p1[MAXN], r1[MAXN], s1[MAXN], st1;
int p2[MAXN], r2[MAXN], s2[MAXN], st2;
int p3[MAXN], r3[MAXN], s3[MAXN], st3;
int p4[MAXN], r4[MAXN], s4[MAXN], st4;
bool ok1, ok2, ok3, ok4;
pair <int, int> edg[MAXN];
int ec = 0, state = -1;
vector <int> e[MAXN];

void Init(int k) {
   n = k;
   for (int i = 0; i < n; i++) 
   {
	   p0[i] = p1[i] = p2[i] = p3[i] = p4[i] = i;
	   r0[i] = r1[i] = r2[i] = r3[i] = r4[i] = 0;
	   s1[i] = s2[i] = s3[i] = s4[i] = 0;
	   c0[i] = 1;
   }
   ok1 = ok2 = ok3 = ok4 = true;
}

int find_snm(int a, int* p, int* r)
{
	int t = a;
	while (p[t] != t) t = p[t];
	while (p[a] != t)
	{
		int x = p[a];
		p[a] = t;
		a = x;
	}
	return t;
}

void union_snm(int a, int b, int* p, int* r)
{
	if (r[a] == r[b]) r[b]++;
	if (r[a] > r[b]) swap(a, b);
	p[a] = b;
}

void add_edge(int a, int b, int* p, int* r, int* s, int& st, bool& ok)
{
	if (!ok) return;
	if (a == st) return;
	if (b == st) return;
	s[a]++;
	s[b]++;
	if ((s[a] > 2) || (s[b] > 2))
	{
		ok = false;
		return;
	}
	a = find_snm(a, p, r);
	b = find_snm(b, p, r);
	if (a == b)
	{
		ok = false;
		return;
	}
	union_snm(a, b, p, r);
}

void make3(int v)
{
	state = -2;
	st1 = v, st2 = e[v][0], st3 = e[v][1], st4 = e[v][2];
	for (int i = 0; i < ec; i++)
	{
		int x = edg[i].first, y = edg[i].second;
		add_edge(x, y, p1, r1, s1, st1, ok1);
		add_edge(x, y, p2, r2, s2, st2, ok2);
		add_edge(x, y, p3, r3, s3, st3, ok3);
		add_edge(x, y, p4, r4, s4, st4, ok4);
	}
}

void Link(int x, int y) {
	edg[ec++] = mp(x, y);
	if (state == -3) return;
	if (state == -2)
	{
		add_edge(x, y, p1, r1, s1, st1, ok1);
		add_edge(x, y, p2, r2, s2, st2, ok2);
		add_edge(x, y, p3, r3, s3, st3, ok3);
		add_edge(x, y, p4, r4, s4, st4, ok4);
		return;
	}
	e[x].push_back(y);
	e[y].push_back(x);
	if (e[x].size() == 3) make3(x);
	else if (e[y].size() == 3) make3(y);
	else
	{
		x = find_snm(x, p0, r0);
		y = find_snm(y, p0, r0);
		if (x == y)
		{
			if (state == -1) state = c0[x];
			else state = -3;
		}
		union_snm(x, y, p0, r0);
		if (p0[x] == y) c0[y] += c0[x];
		else c0[x] += c0[y];
	}
}

int CountCritical() {
    if (state == -1) return n;
	else if (state == -3) return 0;
	else if (state == -2)
	{
		int ans = 0;
		if (ok1) ans++;
		if (ok2) ans++;
		if (ok3) ans++;
		if (ok4) ans++;
		return ans;
	}
	else return state;
}
