#include "grader.h"
#include <bits/stdc++.h>

typedef long long ll;
const int IINF = 0x3f3f3f3f;
const int N = 200179;

int n;
ll k;
std::vector < int > e[N];
std::vector < ll > ec[N];
std::vector < int > en[N];
int ans = IINF;

void deleteVertex(int v)
{
    for (int i = 0; i < e[v].size(); ++i)
    {
        int nv = e[v][i];
        e[nv][en[v][i]] = e[nv].back();
        ec[nv][en[v][i]] = ec[nv].back();
        en[nv][en[v][i]] = en[nv].back();
        en[e[nv].back()][en[nv].back()] = en[v][i];
        e[nv].pop_back();
        ec[nv].pop_back();
        en[nv].pop_back();
    }
}

struct NodeQ
{
    int v, tSize;
    std::vector < int > e;
};
std::vector < NodeQ > qnds;

int dfsQ(int v, int p = -1)
{
    int rr = 1;
    std::vector < int > es;
    for (int i = 0; i < e[v].size(); ++i)
    {
        int nv = e[v][i];
        if (nv == p)
            continue;
        int qv = dfsQ(nv, v);
        rr += qnds[qv].tSize;
        es.push_back(qv);
    }
    qnds.push_back(NodeQ());
    qnds.back().v = v;
    qnds.back().tSize = rr;
    qnds.back().e = es;
    return qnds.size() - 1;
}

class KostilArray
{
private:
    int a[N];
    std::vector < int > chd;

public:
    KostilArray()
    {
        memset(a, 0x3f, sizeof(a));
    }

    const int operator [] (int x) const
    {
        return a[x];
    }

    void setMin(int p, int x)
    {
        if (a[p] == IINF)
            chd.push_back(p);
        a[p] = std::min(a[p], x);
    }

    void reset()
    {
        for (int i : chd)
            a[i] = IINF;
        chd.clear();
    }

    const std::vector < int > & getChd() const
    {
        return chd;
    }
};

void dfs(int v, int p, ll clen, KostilArray & len2cnt, KostilArray & len2cnt1, int cnt = 1)
{
    if (clen > k)
        return;
    len2cnt1.setMin(clen, cnt);
    ans = std::min(ans, len2cnt[k - clen] + cnt);
    for (int i = 0; i < e[v].size(); ++i)
    {
        int nv = e[v][i];
        if (nv == p)
            continue;
        dfs(nv, v, clen + ec[v][i], len2cnt, len2cnt1, cnt + 1);
    }
}

void solve(int someV)
{
    dfsQ(someV);

    int midV = -1;
    int midVK = IINF;
    for (const NodeQ & q : qnds)
    {
        int ca = qnds.size() - q.tSize;
        for (int nv : q.e)
            ca = std::max(ca, qnds[nv].tSize);
        if (ca < midVK)
        {
            midVK = ca;
            midV = q.v;
        }
    }
    qnds.clear();

    static KostilArray len2cnt;
    len2cnt.setMin(0, 0);
    for (int i = 0; i < e[midV].size(); ++i)
    {
        int rv = e[midV][i];
        static KostilArray len2cnt1;
        dfs(rv, midV, ec[midV][i], len2cnt, len2cnt1);
        for (int j : len2cnt1.getChd())
            len2cnt.setMin(j, len2cnt1[j]);
        len2cnt1.reset();
    }
    len2cnt.reset();

    deleteVertex(midV);
    std::vector < int > epp = e[midV];
    for (int nv : epp)
        solve(nv);
}

int best_path(int N, int K, int H[][2], int L[])
{
    n = N;
    k = K;
    for (int i = 0; i < n - 1; ++i)
    {
        en[H[i][0]].push_back(e[H[i][1]].size());
        en[H[i][1]].push_back(e[H[i][0]].size());

        e[H[i][0]].push_back(H[i][1]);
        ec[H[i][0]].push_back(L[i]);
        e[H[i][1]].push_back(H[i][0]);
        ec[H[i][1]].push_back(L[i]);
    }

    solve(0);

    return ans >= IINF ? -1 : ans;
}
