#include "grader.h"
#include <vector>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

const static int MAXN = 1002;
vector <int> e[MAXN];
int pe[MAXN];
bool ww[MAXN];

void dfs_p(int v, int par)
{
	ww[v] = true;
	pe[v] = par;
	for (int i = 0; i < e[v].size(); i++)
	{
		if (!ww[e[v][i]])
		{
			dfs_p(e[v][i], v);
		}
	}
}

void enc10(int x)
{
	for (int i = 0; i < 10; i++)
	{
		encode_bit(x % 2);
		x /= 2;
	}
}

void enc5(int x)
{
	for (int i = 0; i < 5; i++)
	{
		encode_bit(x % 2);
		x /= 2;
	}
}

int c3 = 0;
int xt[3];

void enc3(int x)
{
	x++;
	xt[c3++] = x;
	if (c3 == 3)
	{
		enc5(xt[2] * 9 + xt[1] * 3 + xt[0] * 1);
		c3 = 0;
	}
}

void encode(int nv, int nh, int ne, int *v1, int *v2){
	int d[MAXN];
	bool w[MAXN];
	dfs_p(0, 0);
	for (int i = 0; i < nv; i++) e[i].clear(), ww[i] = false;
	for (int i = 0; i < ne; i++)
	{
		e[v1[i]].push_back(v2[i]);
		e[v2[i]].push_back(v1[i]);
	}
	dfs_p(0, 0);
 	for (int i = 0; i < nv; i++) enc10(pe[i]);
	w[MAXN - 1] = true;
	for (int i = 0; i < nh; i++)
	{
		for (int j = 0; j < nv; j++) d[j] = MAXN, w[j] = false;
		d[i] = 0;
		for (int j = 0; j < nv; j++)
		{
			int ml = MAXN - 1;
			for (int l = 0; l < nv; l++)
			{
				if (w[l]) continue;
				if (w[ml] || (d[l] < d[ml])) ml = l;
			}
			w[ml] = true;
			for (int l = 0; l < e[ml].size(); l++)
			{
				d[e[ml][l]] = min(d[e[ml][l]], d[ml] + 1);
			}
		}
		for (int j = 0; j < nv; j++) 
			enc3(d[j] - d[pe[j]]);
	}
	if (c3 != 0) enc3(0);
	if (c3 != 0) enc3(0);
}

int pd[MAXN];
int df[MAXN];
vector <int> e2[MAXN];
int sh;

int dec10()
{
	int ans = 0, s2 = 1;
	for (int i = 0; i < 10; i++)
	{
		ans += decode_bit() * s2;
		s2 *= 2;
	}
	return ans;
}

int dec5()
{
	int ans = 0, s2 = 1;
	for (int i = 0; i < 5; i++)
	{
		ans += decode_bit() * s2;
		s2 *= 2;
	}
	return ans;
}

int d3 = 0, cur3;

int dec3()
{
	if (d3 == 0) cur3 = dec5();
	d3 = (d3 + 1) % 3;
	int ans = (cur3 % 3) - 1;
	cur3 /= 3;
	return ans;
}

void dfs_e(int v, int dst)
{
	dst += df[v];
	hops(sh, v, dst);
	for (int i = 0;  i < e2[v].size(); i++)
	{
		dfs_e(e2[v][i], dst);
	}
}

void decode(int nv, int nh) {
	for (int i = 0; i < nv; i++) e2[i].clear();
	for (int i = 0; i < nv; i++) 
	{
		pd[i] = dec10();
		if (pd[i] != i) e2[pd[i]].push_back(i);
	}
	for (int i= 0; i < nh; i++)
	{
		for (int j = 0; j < nv; j++) df[j] = dec3();
		int cur = 0, cv = i;
		while (pd[cv] != cv)
		{
			cur -= df[cv];
			cv = pd[cv];
		}
		sh = i;
		dfs_e(cv, cur);
	}
}
