#include <stdlib.h>
#include "grader.h"
#include <algorithm>

using namespace std;

const int MAXN = 250001;
int a[MAXN];
int w[MAXN];
const long long MODULE = 1000 * 1000 * 1000 + 9;
int valid(int n, int inputSeq[])
{
	int cr = -1;
	for (int i = 0; i < n; i++)
	{
		a[i] = inputSeq[i];
		if (inputSeq[i] <= n)
		{
			int c = (inputSeq[i] + n - i) % n;
			if (cr == c) continue;
			else if (cr == -1) cr = c;
			else cr = -2;
		}
	}
	sort(a, a + n);
	for (int i = 0; i < n - 1; i++)
	{
		if ((a[i] == a[i + 1])) return 0;
	}
	if (cr == -2) return 0;
	else return 1;	
}

int replacement(int n, int gondolaSeq[], int replacementSeq[])
{
	int cr = -1;
	for (int i = 0; i < n; i++)
	{
		if (gondolaSeq[i] <= n)
		{
			cr = (gondolaSeq[i] + n - i) % n;
		}
	}
	int mx = 0;
	for (int i = 1; i < MAXN; i++) w[i] = -1;
	if (cr == -1) cr = 0;
	for (int i = 0; i < n; i++)
	{
	   mx = max(gondolaSeq[i], mx);
	   w[gondolaSeq[i]] = i;
	   a[i] = (i + cr) % n;
	   if (a[i] == 0) a[i] = n;
	}
	for (int i = n + 1; i <= mx; i++)
	{
		if (w[i] == -1) replacementSeq[i - n - 1] = a[w[mx]], a[w[mx]] = i;
		else replacementSeq[i - n - 1] = a[w[i]], a[w[i]] = i;
	}
	return mx - n;
}

long long pw(long long x, long long pwr)
{
	if (pwr == 0) return 1;
	long long res = pw(x, pwr / 2);
	res = (res * res) % MODULE;
	if (pwr % 2 == 1) res = (res * x) % MODULE;
	return res;
}

int countReplacement(int n, int inputSeq[])
{
	if (valid(n, inputSeq) == 0) return 0;
	int cr = -1;
	for (int i = 0; i < n; i++)
	{
		if (inputSeq[i] <= n)
		{
			cr = (inputSeq[i] + n - i) % n;
		}
	}
  long long ans = 1;
  sort(a, a + n);
  int p = 0;
  while ((p != n) && (a[p] <= n)) p++;
  long long g = n + 1;
  while (p != n)
  {
	  ans = ans * (pw(n - p, a[p] - g));
	  ans = ans % MODULE;
	  g = a[p++] + 1;
  }
  if (cr == -1) ans = (ans  * (long long)n) % MODULE;
  return ans;
}
	