#include "grader.h"
#include <algorithm>
#include <cmath>

using namespace std;

const int MAXN = 8000001;
const int INF = 2147483647;
int rmql[MAXN], rmqr[MAXN];

	
void upd(int v, int nl, int nr) 
{
	if (rmqr[v] < nl) rmql[v] = rmqr[v] = nl;
	else if (rmql[v] > nr) rmqr[v] = rmql[v] = nr;
	else rmql[v] = max(rmql[v], nl), rmqr[v] = min(rmqr[v], nr);
}

void push(int v)
{
	upd(v * 2 + 1, rmql[v], rmqr[v]);
	upd(v * 2 + 2, rmql[v], rmqr[v]);
	rmql[v] = 0, rmqr[v] = INF;
}

int z1, z2, lv, rv;
int ans[MAXN];

void modify_rmq(int v, int l, int r)
{
	if ((l > z2) || (z1 > r)) return;
	if ((z1 <= l) && (r <= z2)) upd(v, lv, rv);
	else
	{
		push(v);
		modify_rmq(v * 2 + 1, l, (l + r) / 2);
		modify_rmq(v * 2 + 2, (l + r) / 2 + 1, r);
	}
}

void getans(int v, int l, int r)
{
	if (l == r) ans[l] = rmql[v];
	else
	{
		push(v);
		getans(v * 2 + 1, l, (l + r) / 2);
		getans(v * 2 + 2, (l + r) / 2 + 1, r);
	}
}
	
void buildWall(int n, int k, int op[], int left[], int right[], int height[], int finalHeight[]){
   for (int i = 0; i < MAXN; i++) rmql[i] = 0, rmqr[i] = 0;
   for (int i = 0; i < k; i++)
   {
		   z1 = left[i], z2 = right[i];
	   if (op[i] == 1) lv = height[i], rv = INF;
	   else lv = 0, rv = height[i];
	   modify_rmq(0, 0, n - 1);
   }
   getans(0, 0, n - 1);
   for (int i = 0; i < n; i++) finalHeight[i]= ans[i];
}

