#include "grader.h"  
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

const int N = 1000111;
const int INF = 2000000001;

int narr[N*2], *near[N], ncount[N], ncurr[N];
struct Node
{
	int par;
	int bcount;
} nodes[N];
int bc, minn, mino;

int LocateCentre(int n, int pp[], int S[], int D[])
{
	minn = INF;
	bc = 0;
	for (int i = 0; i < n; ++i)
		bc += pp[i];
	for (int i = 0; i < n-1; ++i)
	{
		++ncount[S[i]];
		++ncount[D[i]];
	}
	near[0] = narr;
	for (int i = 1; i < n; ++i)
		near[i] = near[i - 1] + ncount[i - 1];
	for (int i = 0; i < n-1; ++i)
	{
		near[S[i]][ncurr[S[i]]++] = D[i];
		near[D[i]][ncurr[D[i]]++] = S[i];
	}
	nodes[0].par = -1;
	std::vector < int > q;
	q.push_back(0);
	for (int i = 0; i < q.size(); ++i)
	{
		int curr = q[i];
		for (int j = 0; j < ncount[curr]; ++j)
		{
			int t = near[curr][j];
			if (t == nodes[curr].par)
				continue;
			q.push_back(t);
		}
	}
	for (int i = n - 1; i >= 0; --i)
	{
		int curr = q[i];
		nodes[curr].bcount = pp[curr];
		for (int j = 0; j < ncount[curr]; ++j)
			nodes[curr].bcount += nodes[near[curr][j]].bcount;
	}
	for (int i = 0; i < n; ++i)
	{
		int cm;
		if (nodes[i].par == -1)
			cm = 0;
		else
			cm = nodes[nodes[i].par].bcount;
		for (int j = 0; j < ncount[i]; ++j)
			cm = std::max(cm, nodes[near[i][j]].bcount);
		if (minn > cm)
		{
			minn = cm;
			mino = i;
		}
	}
	return mino;
}