#include <bits/stdc++.h>

typedef long long ll;
const ll N = 1 << 30;
const int LINF = 0x3f3f3f3f;

struct Node
{
    Node * l, * r;
    int cl, cr;

    int set;
    ll sum, maxPrefSum;
    int maxPrefI;

    Node(int ncl, int ncr) :
        l(nullptr), r(nullptr),
        cl(ncl), cr(ncr),
        set(-LINF), sum(0), maxPrefSum(0),
        maxPrefI(0)
    {
    }

    void use()
    {
        if (cl == cr || l != nullptr)
            return;
        l = new Node(cl, (cl+cr) / 2);
        r = new Node((cl+cr) / 2 + 1, cr);
    }

    void thisSet(ll qx)
    {
        set = qx;
        sum = 1ll * qx * (cr - cl + 1);
        if (qx > 0)
        {
            maxPrefSum = sum;
            maxPrefI = cr - cl + 1;
        } else {
            maxPrefSum = 0;
            maxPrefI = 0;
        }
    }

    void down()
    {
        if (set == -LINF)
            return;
        l->thisSet(set);
        r->thisSet(set);
        set = -LINF;
    }

    void update()
    {
        sum = l->sum + r->sum;
        maxPrefSum = l->maxPrefSum;
        maxPrefI = l->maxPrefI;
        if (maxPrefSum < l->sum + r->maxPrefSum)
        {
            maxPrefSum = l->sum + r->maxPrefSum;
            maxPrefI = (l->cr - l->cl + 1) + r->maxPrefI;
        }
    }

    void segSet(ll ql, ll qr, ll qx)
    {
        if (cl > qr || cr < ql)
            return;
        if (ql <= cl && cr <= qr)
        {
            thisSet(qx);
            return;
        }

        use();
        down();
        l->segSet(ql, qr, qx);
        r->segSet(ql, qr, qx);
        update();
    }

    ll start(ll h)
    {
        if (maxPrefSum <= h)
            return cr - cl + 1;
        if (cl == cr)
            return 0;
        use();
        down();
        ll ls = l->start(h);
        if (ls == (l->cr - l->cl + 1))
            return ls + r->start(h - l->sum);
        return ls;
    }
};

int main()
{
    std::ios::sync_with_stdio(false);

    ll n;
    std::cin >> n;
    Node * st = new Node(0, N - 1);
    while (true)
    {
        std::string s;
        std::cin >> s;
        if (s == "Q")
        {
            ll h;
            std::cin >> h;
            std::cout << std::min(st->start(h), n) << "\n";
        } else if (s == "I")
        {
            ll l, r, x;
            std::cin >> l >> r >> x;
            --l;
            --r;
            st->segSet(l, r, x);
        } else
            break;
    }

    return 0;
}
