#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include "grader.h"

using namespace std;

const int MAXR = 5001;
const int MAXC = 200;
const int PART = 15;
const int PARTC = 335;
const int inf = 1000 * 5001 * 200;
int ps, r, c;
int h[MAXR][MAXC];
int v[MAXR][MAXC];
struct matrix
{
	int t[200][200];
};

vector <matrix> e[PARTC];
int es[PARTC];

void defmat(matrix& a)
{
	for (int i = 0; i < c; i++)
	{
		for (int j = 0; j < c; j++)
		{
			a.t[i][j] = inf;
		}
		a.t[i][i] = 0;
	}
}

int bs[MAXC][MAXC];
void conc(matrix a, matrix b, matrix &rs)
{
	for (int i = 0; i < c; i++)
	{
		int bp = 0;
		for (int j = 1; j < c; j++)
		{
			if (a.t[i][j] + b.t[j][i] < a.t[i][bp] + b.t[bp][i]) bp = j;
		}
		bs[i][i] = bp;
		rs.t[i][i] = a.t[i][bp] + b.t[bp][i];
	}
	for (int d = 1; d < c; d++)
	{
		for (int i = 0; i < c - d; i++)
		{
			int j = i + d;
			int bp = bs[i + 1][j];
			for (int l = bs[i][j - 1]; l < bs[i + 1][j]; l++)
			{
				if (a.t[i][l] + b.t[l][j] < a.t[i][bp] + b.t[bp][j]) bp = l;
			}
			bs[i][j] = bp;
			rs.t[i][j] = a.t[i][bp] + b.t[bp][j];
			bp = bs[j][i + 1];
			for (int l = bs[j - 1][i]; l < bs[j][i + 1]; l++)
			{
				if (a.t[j][l] + b.t[l][i] < a.t[j][bp] + b.t[bp][i]) bp = l;
			}
			bs[j][i] = bp;
			rs.t[j][i] = a.t[j][bp] + b.t[bp][i];
		}
	}
}

int sm[MAXC];

void calc(int id)
{
	matrix c2;
	defmat(e[id][0]);
	for (int i = id * PART; i < min(r, (id + 1) * PART); i++)
	{
		sm[0] = 0;
		for (int j = 0; j < c - 1; j++) sm[j + 1] = sm[j] + h[i][j];
		for (int j = 0; j < c; j++)
		{
			for (int l = 0; l < c; l++)
			{
				c2.t[j][l] = abs(sm[l] - sm[j]) + v[i][l];
			}
		}
		conc(e[id][0], c2, e[id][0]);
	}
}


void init(int R, int C, int H[5000][200], int V[5000][200])
{
	r = R;
	c = C;
	for (int i = 0; i < r; i++)
	{
		for (int j = 0; j < c; j++)
		{
			h[i][j] = H[i][j];
			v[i][j] = V[i][j];
		}
	}
	ps = (R + PART - 1) / PART;
	for (int i = 0; i < c; i++) v[r - 1][i] = 0;
	es[0] = 0;
	while (ps > (1 << es[0])) es[0]++;
	es[0]++;
	for (int i = 1; i < ps; i++)
	{
		es[i] = 0;
		while (i % (1 << es[i]) == 0) es[i]++;
	}
	for (int i = 0; i < ps; i++) 
	{
		e[i].resize(es[i]);
		calc(i);
	}
	es[ps] = es[0];
	e[ps].resize(es[0]);
	for (int i = 0; i < es[ps]; i++)
	{
		defmat(e[ps][i]);
	}
	for (int i = ps - 1; i >= 0; i--)
	{
		for (int j = 0; j < es[i] - 1; j++)
		{
			conc(e[i][j], e[min(ps, i + (1 << j))][j], e[i][j + 1]);
		}
	}
}

void upd(int p)
{
	calc(p);
	for (int i = 0; i < es[0] - 1; i++)
	{
		int v = (p / (1 << (i + 1))) * (1 << (i + 1));
		conc(e[v][i], e[min(v + (1 << i), ps)][i], e[v][i + 1]);
	}
}

void changeH(int P, int Q, int W)
{
	h[P][Q] = W;
	upd(P / PART);
}

void changeV(int P, int Q, int W)
{
	v[P][Q] = W;
	upd(P / PART);
}

int escape(int V1, int V2)
{
	return e[0][es[0] - 1].t[V1][V2];
}