#include "grader.h"  
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

const int D = 20;
const int N = 1000555;

struct Letter
{
	char c;
	int pos;
	int dp[D];
} text[N];
int state[N], stateCount = 1, count = 0;

void Init()
{
	state[0] = -1;
}

void TypeLetter(char l)
{
	state[stateCount] = count;
	text[count].c = l;
	memset(text[count].dp, -1, sizeof(text[count].dp));
	int cr = state[stateCount - 1];
	if (cr == -1)
		text[count].pos = 0;
	else
		text[count].pos = text[cr].pos + 1;
	for (int i = 0; i < D && cr != -1; ++i)
	{
		text[count].dp[i] = cr;
		cr = text[cr].dp[i];
	}
	++count;
	++stateCount;
}

void UndoCommands(int u)
{
	state[stateCount] = stateCount - u - 1;
	++stateCount;
}

char GetLetter(int p)
{
	int d = D - 1;
	int c = state[stateCount - 1];
	while (text[c].pos != p)
	{
		int nc = text[c].dp[d];
		if (nc != -1 && text[nc].pos >= p)
			c = nc;
		else
			--d;
	}
	return text[c].c;
}