#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 500001;
int m;


pair <int, int> kds[MAXN];
pair <int, int> a[MAXN];
int ml[MAXN], p[MAXN], e[MAXN], rmq[4 * MAXN];
vector <int> ks[MAXN];
int z1, z2;

void modify_rmq(int v, int l, int r)
{
	if (r < z1) return;
	if (z1 < l) return;
	if (l == r) rmq[v]++;
	else
	{
		modify_rmq(v * 2 + 1, l, (l + r) / 2);
		modify_rmq(v * 2 + 2, (l + r) / 2 + 1, r);
		rmq[v] = rmq[v * 2 + 1] * rmq[v * 2 + 2];
	}
	rmq[v] = rmq[v] % m;
}

int get_rmq(int v, int l, int r)
{
	if (r < z1) return 1;
	if (l > z2) return 1;
	if ((z1 <= l) && (r <= z2)) return rmq[v];
	else
	{
		return (get_rmq(v * 2 + 1, l, (l + r) / 2) * get_rmq(v * 2 + 2, (l + r) / 2 + 1, r)) % m;
	}
}

int main()
{
#ifdef _DEBUG
	FILE* stream;
	freopen_s(&stream, "input.txt", "r", stdin);
	freopen_s(&stream, "output.txt", "w", stdout);
#endif
	int f, k;
	scanf("%d%d%d", &f, &k, &m);
	for (int i = 0; i < 4 * k; i++) rmq[i] = 1;
	for (int i = 0; i < k; i++) kds[i] = make_pair(0, i), e[i] = 0;
	for (int i = 0; i < f; i++)
	{
		scanf("%d%d", &a[i].first, &a[i].second);
		a[i].second--;
		kds[a[i].second].first = max(kds[a[i].second].first, a[i].first);
	}
	sort(kds, kds + k);
	for (int i = 0; i < k; i++)
	{
		ml[i] = kds[i].first;
		p[kds[i].second] = i;
	}
	int pr = 0;
	sort(a, a + f);
	for (int i = 0; i < f; i++)
	{
		ks[p[a[i].second]].push_back(a[i].first);
	}
	int res = 0;
	for (int i = 0; i < k; i++)
	{
		while (a[pr].first * 2 <= ml[i])
		{
			z1 = p[a[pr++].second];
			e[z1]++;
			modify_rmq(0, 0, k - 1);
		}
		int lg = i + 1, rg = k;
		while (lg < rg)
		{
			int md = (lg + rg) / 2;
			if (ml[md] >= ks[i][e[i]] * 2) rg = md;
			else lg = md + 1;
		}
		z1 = 0, z2 = i - 1;
		int g1 = get_rmq(0, 0, k - 1);
		z1 = i + 1, z2 = lg - 1;
		int g2 = get_rmq(0, 0, k - 1);
		res = (res + g1 * e[i]) % m;
		res = (res + g1 * g2) % m;
	}
	cout << res << endl;
	return 0;
}