#include "grader.h"  
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

#include "grader.h"

const int N = 1000111;
const int INF = 2000000000;

std::vector < int > near[N];
struct Node
{
	int num;
	int par;
	int bcount, btpc, maxd;
} nodes[N];
int nc, bc = 0, minn = INF, mino;

int LocateCentre(int n, int pp[], int S[], int D[])
{
	for (int i = 0; i < n-1; ++i)
	{
		near[S[i]].push_back(D[i]);
		near[D[i]].push_back(S[i]);
	}
	nodes[0].num = 0;
	nodes[0].par = -1;
	nc = 1;
	for (int i = 0; i < n; ++i)
	{
		bc += pp[i];
		int v = nodes[i].num;
		for (int j = 0; j < near[v].size(); ++j)
			if (near[v][j] != nodes[i].par)
			{
				nodes[nc].num = near[v][j];
				nodes[nc].par = i;
				++nc;
			}
	}
	for (int i = n-1; i >= 0; --i)
	{
		nodes[i].bcount += pp[nodes[i].num];
		int p = nodes[i].par;
		if (p != 0)
		{
			nodes[p].bcount += nodes[i].bcount;
			if (nodes[p].maxd < nodes[i].bcount)
				nodes[p].maxd = nodes[i].bcount;
		}
	}
	for (int i = n-1; i >= 0; --i)
	{
		nodes[i].btpc = bc - nodes[i].bcount;
		nodes[i].maxd = std::max(nodes[i].maxd, nodes[i].btpc);
		if (nodes[i].maxd < minn)
		{
			minn = nodes[i].maxd;
			mino = nodes[i].num;
		}
	}
	for (int i = 0; i < n; ++i)
	{
		std::cerr << i << " (" << nodes[i].num << ") = " << nodes[i].par << " " << nodes[i].maxd << "\n";
	}
	return mino;
}
