#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

const int MAXN = 100001;
const int INF = 1000 * 1000 * 1001;
int d[MAXN], t[MAXN];
set <pair <int, int> > st;
vector <pair <int, int> > e[MAXN];
void add(int id, int tm)
{
		if (tm > d[id]) return;
	pair <int, int> pp = make_pair(d[id], id);
	set <pair <int, int> >::iterator it = st.lower_bound(pp);
	if ((it != st.end()) && (*it == pp)) st.erase(pp);
	d[id] = tm;
	if (d[id] < t[id]) swap(t[id], d[id]);
	if (d[id] != INF) st.insert(make_pair(d[id], id));
}

int travel_plan(int N, int M, int R[][2], int L[], int K, int P[])
{
	for (int i = 0; i < N; i++)
	{
		d[i] = t[i] = INF;
	}
	for (int i = 0; i < K; i++)
	{
		add(P[i], 0);
		add(P[i], 0);
	}
	for (int i = 0; i < M; i++)
	{
		e[R[i][0]].push_back(make_pair(R[i][1], L[i]));
		e[R[i][1]].push_back(make_pair(R[i][0], L[i]));
	}
	while (!st.empty())
	{
		int v = st.begin()->second;
		st.erase(*st.begin());
		for (int i = 0; i < e[v].size(); i++)
		{
			add(e[v][i].first, d[v] + e[v][i].second);
		}
	}
	return d[0];
}