#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 500002;
int t[MAXN], l[MAXN], m[MAXN];
const int INF = 1000 * 1000 * 10;
int rmql[4 * MAXN], rmqr[4 * MAXN];
int a[MAXN], b[MAXN];
int p[MAXN];

bool cmpl(int x, int y)
{
	return make_pair(l[x], x) < make_pair(l[y], y);
}

bool cmpt(int x, int y)
{
	return make_pair(make_pair(t[x], l[x]), x) < make_pair(make_pair(t[y], l[y]), y);
}

int z1, z2;

void create_rmql(int v, int l, int r)
{
	rmql[v] = -INF;
	if (l != r)
	{
		int md = (l + r) / 2;
		create_rmql(v * 2 + 1, l, md);
		create_rmql(v * 2 + 2, md + 1, r);
	}
}

void modify_rmql(int v, int l, int r)
{
	if (l > z1) return;
	if (r < z1) return;
	if (l == r)
	{
		rmql[v] = z2;
	}
	else
	{
		int md = (l + r) / 2;
		modify_rmql(v * 2 + 1, l, md);
		modify_rmql(v * 2 + 2, md + 1, r);
		rmql[v] = max(rmql[v * 2 + 1], rmql[v * 2 + 2]);
	}
}

int find_rmql(int v, int l, int r)
{
	if (l > z2) return -INF;
	if (r < z1) return -INF;
	if ((z1 <= l) && (r <= z2))
	{
		return rmql[v];
	}
	else
	{
		int md = (l + r) / 2;
		return max(find_rmql(v * 2 + 1, l, md), find_rmql(v * 2 + 2, md + 1, r));
	}
}

void create_rmqr(int v, int l, int r)
{
	rmqr[v] = -INF;
	if (l != r)
	{
		int md = (l + r) / 2;
		create_rmqr(v * 2 + 1, l, md);
		create_rmqr(v * 2 + 2, md + 1, r);
	}
}

void modify_rmqr(int v, int l, int r)
{
	if (l > z1) return;
	if (r < z1) return;
	if (l == r)
	{
		rmqr[v] = z2;
	}
	else
	{
		int md = (l + r) / 2;
		modify_rmqr(v * 2 + 1, l, md);
		modify_rmqr(v * 2 + 2, md + 1, r);
		rmqr[v] = max(rmqr[v * 2 + 1], rmqr[v * 2 + 2]);
	}
}

int find_rmqr(int v, int l, int r)
{
	if (l > z2) return -INF;
	if (r < z1) return -INF;
	if ((z1 <= l) && (r <= z2))
	{
		return rmqr[v];
	}
	else
	{
		int md = (l + r) / 2;
		return max(find_rmqr(v * 2 + 1, l, md), find_rmqr(v * 2 + 2, md + 1, r));
	}
}

int f[MAXN];
vector <int> sd;

int main()
{
	int n, u, d, s;
	cin >> n >> u >> d >> s;
	n += 2;
	t[0] = m[0] = 0;
	l[0] = s;
	for (int i = 1; i<= n - 2; i++)
	{
		cin >> t[i] >> l[i] >> m[i];
	}
	t[n - 1] = INF;
	m[n - 1] = 0;
	l[n - 1] = s;
	for (int i = 0; i < n; i++)
	{
		a[i] = b[i] = i;
	}
	sort(a, a + n, cmpl);
	for (int i = 0; i < n; i++)
	{
		p[a[i]] = i;
	}
	sort(b, b + n, cmpt);
	for (int i = 0; i < 4 * MAXN; i++) rmql[i] = rmqr[i] = -INF;
	z1 = p[0], z2 = l[0] * d;
	modify_rmql(0, 0, n - 1);
	z1 = p[0], z2 = -l[0] * u;
	modify_rmqr(0, 0, n - 1);
	for (int i = 1; i < n; i++)
	{
		int v = b[i];
		sd.push_back(v);
		int lg = 0, rg = n;
		while (lg < rg)
		{
			int md = (lg + rg) / 2;
			if (l[a[md]] > l[v]) rg = md;
			else lg = md + 1;
		}
		z1 = 0, z2 = lg - 1;
		f[v] = find_rmql(0, 0, n - 1) - d * l[v];
		z1 = lg, z2 = n - 1;
		f[v] = max(f[v], find_rmqr(0, 0, n - 1) + u * l[v]);
		f[v] += m[v];
		if ((i == n - 1) || (t[v] != t[b[i + 1]]))
		{
			for (int j = 1; j < sd.size(); j++)
			{
				f[sd[j]] = max(f[sd[j]], f[sd[j - 1]] - d * (l[sd[j]] - l[sd[j - 1]]) + m[sd[j]]);
			}
			for (int j = sd.size() - 2; j >= 0; j--)
			{
				f[sd[j]] = max(f[sd[j]], f[sd[j + 1]] - u * (l[sd[j + 1]] - l[sd[j]]) + m[sd[j]]);
			}
			for (int j = 0; j < sd.size(); j++)
			{
				z1 = p[sd[j]], z2 = f[sd[j]] + d * l[sd[j]];
				modify_rmql(0, 0, n - 1);
				z2 = f[sd[j]] - u * l[sd[j]];
				modify_rmqr(0, 0, n - 1);
			}
			sd.clear();
		}
	}
	cout << f[n - 1] << endl;
	return 0;
}