#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr ksgkfjasdhf
#define stderr dfjgdfjkghd
#endif

#define sz(x) ((int)x.size())
#define mp(x,y) make_pair(x, y)

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const double EPS = 1e-8;
const int DX[] = {1, 0, -1,  0, 1, -1,  1, -1};
const int DY[] = {0, 1,  0, -1, 1, -1, -1,  1};

const int N = 1 << 19;

struct SegTree
{
	ll a[N*2-1];
public:
	SegTree()
	{
		for (int i = 0; i < N*2-1; ++i)
			a[i] = -LINF;
	}

	const ll operator [] (int x) const
	{
		return a[N-1+x];
	}

	void set(int x, ll v)
	{
		x += N-1;
		a[x] = v;
		while (x != 0)
		{
			x = (x - 1) >> 1;
			int x1 = x*2 + 1, x2 = x*2 + 2;
			a[x] = max(a[x1], a[x2]);
		}
	}

	ll getMax(int l, int r, int c = 0, int cl = 0, int cr = N - 1)
	{
		if (l > cr || r < cl)
			return -LINF;
		if (l <= cl && cr <= r)
			return a[c];
		ll r1 = getMax(l, r, c*2+1, cl, (cl+cr)>>1);
		ll r2 = getMax(l, r, c*2+2, ((cl+cr)>>1) + 1, cr);
		return max(r1, r2);
	}
} dVP, dVM;

struct Event
{
	ll p;
	ll c;
};

int n;
ll cp, cm, s;
vector < Event > events[N];
ll d[N];

int main()
{
/*
	freopen("input.txt", "w", stdout);
*/
    ios::sync_with_stdio(false);

	cin >> n >> cp >> cm >> s;
	for (int i = 0; i < n; ++i)
	{
		int t;
		Event e;
		cin >> t >> e.p >> e.c;
		events[t].push_back(e);
	}
	for (int i = 0; i < N; ++i)
		sort(events[i].begin(), events[i].end(), [](const Event&a, const Event&b){return a.p<b.p;});

	for (int i = 0; i < N; ++i)
		d[i] = -LINF;
	d[s] = 0;
	dVP.set(s, cp*s);
	dVM.set(s, -cm*s);

	for (int i = 0; i < N; ++i)
	{
		static ll csum[N];
		csum[0] = 0;
		for (int j = 0; j < sz(events[i]); ++j)
			csum[j+1] = csum[j] + events[i][j].c;

		vector < ll > mm1;
		for (int k = 0; k < sz(events[i]); ++k)
		{
			const Event & ep = events[i][k];
			mm1.push_back(max(dVP.getMax(0, ep.p), dVM.getMax(ep.p, N-1) + ep.p*(cm+cp)) - csum[k]);
		}

		vector < ll > mm3;
		for (int k = 0; k < sz(events[i]); ++k)
		{
			const Event & ep = events[i][k];
			mm3.push_back(max(dVM.getMax(ep.p, N-1), dVP.getMax(0, ep.p) - ep.p*(cp+cm)) + csum[k+1]);
		}

		vector < ll > mm1p;
		mm1p.push_back(-LINF);
		for (ll k : mm1)
			mm1p.push_back(max(mm1p.back(), k));
		vector < ll > mm3s;
		mm3s.push_back(-LINF);
		for (ll k = sz(mm3) - 1; k >= 0; --k)
			mm3s.push_back(max(mm3s.back(), mm3[k]));

		for (int j = 0; j < sz(events[i]); ++j)
		{
			const Event & e = events[i][j];
			ll cd = -LINF;
			cd = max(cd, dVP.getMax(0, e.p) - e.p*cp);
			cd = max(cd, dVM.getMax(e.p, N-1) + e.p*cm);
			cd = max(cd, mm1p[j] + csum[j] - e.p*cp);
			cd = max(cd, mm3s[sz(events[i])-j-1] + e.p*cm - csum[j+1]);
			d[e.p] = cd + e.c;
		}
		for (int j = 0; j < sz(events[i]); ++j)
		{
			const Event & e = events[i][j];
			dVP.set(e.p, d[e.p]+cp*e.p);
			dVM.set(e.p, d[e.p]-cm*e.p);
		}
	}

	ll ans = -LINF;
	for (int i = 0; i <= s; ++i)
		ans = max(ans, d[i] - cp*(s-i));
	for (int i = s+1; i < N; ++i)
		ans = max(ans, d[i] - cm*(i-s));
	cout << ans << "\n";

    return 0;
}
