#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

const int N = 500555;;
const int P = 25;
const int INF = 0x3f3f3f3f;

long long n, r, ox, oy;

int qua(int x, int y)
{
	if (x > 0 && y > 0)
		return 1;
	if (x <= 0 && y > 0)
		return 2;
	if (x < 0 && y <= 0)
		return 3;
	return 4;
}

bool mq;
struct Point
{
	long long x, y;
	Point(long long nx=0, long long ny=0) : x(nx), y(ny) {}
	
	bool operator < (const Point & b) const
	{
		if (mq)
			return (ox-x)*(b.y-oy) < (ox-b.x)*(y-oy);
		else
			return (x-ox)*(b.y-oy) < (b.x-ox)*(y-oy);
	}
};

int cur = 0;

long double findPerX(const Point & p, long long x)
{
	return (long double)(x-ox) * (p.y - oy) / (p.x - ox) + oy;
}

long double findPerY(const Point & p, long long y)
{
	std::swap(ox, oy);
	Point p1;
	p1.x = p.y;
	p1.y = p.x;
	long double r = findPerX(p1, y);
	std::swap(ox, oy);
	return r;
}

long double sqpos(const Point & p)
{
	long long side;
	long double x;
	if (p.x == ox)
	{
		if (p.y < oy)
			side = 0;
		else
			side = 2;
		x = p.x;
	} else if (p.y == oy)
	{
		if (p.x < ox)
			side = 3;
		else
			side = 1;
		x = p.y;
	} else {
		int q = qua(p.x - ox, p.y - oy);
		long double a0, a1, a2, a3;
		a0 = findPerY(p, 0);
		a1 = findPerX(p, n);
		a2 = findPerY(p, n);
		a3 = findPerX(p, 0);
		if (q == 3)
		{
			if (a0 < 0)
			{
				x = a3;
				side = 3;
			} else {
				x = a0;
				side = 0;
			}
		} else if (q == 4) {
			if (a0 > n)
			{
				x = a1;
				side = 1;
			} else {
				x = a0;
				side = 0;
			}
		} else if (q == 1) {
			if (a1 > n)
			{
				x = a2;
				side = 2;
			} else {
				x = a1;
				side = 1;
			}
		} else {
			if (a2 < 0)
			{
				x = a3;
				side = 3;
			} else {
			x = a2;
				side = 2;
			}
		}
	}
	switch (side)
	{
	case 0: return x;
	case 1: return n+x;
	case 2: return 3*n-x;
	case 3: return 4*n-x;
	};
	return 0;
}

int rez[N*4], ru;
bool cantAdd[N*4];

struct Line
{
	long long a, b, c;
	Line(long long na, long long nb, long long nc) : a(na), b(nb), c(nc) {}
};

Line getLine(const Point & a, const Point & b)
{
	if (a.x == b.x)
		return Line(1, 0, -a.x);
	if (a.y == b.y)
		return Line(0, 1, -a.y);
	return Line(b.y - a.y, a.x - b.x, a.y*(b.x-a.x) - a.x*(b.y-a.y));
}

bool razs(const Point & a1, const Point & a2, const Point & b1, const Point & b2)
{
	Line l = getLine(a1, a2);
	long long q = l.a*b1.x + l.b*b1.y + l.c;
	long long w = l.a*b2.x + l.b*b2.y + l.c;
	return (q > 0 && w < 0) || (q < 0 && w > 0);
}

bool otrp(const Point & a1, const Point & a2, const Point & b1, const Point & b2)
{
	return razs(a1, a2, b1, b2) && razs(b1, b2, a1, a2);
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	scanf("%lld%lld%lld%lld", &n, &r, &ox, &oy);
	for (int i = 0; i < r; ++i)
	{
		int p;
		scanf("%d", &p);
		Point r[P];
		mq = false;
		bool eee = false;
		for (int j = 0; j < p; ++j)
		{
			scanf("%lld%lld", &r[j].x, &r[j].y);
			if (j > 0)
			{
				long long ax = r[j].x - ox, ay = r[j].y - oy, bx = r[j-1].x - ox, by = r[j-1].y - oy;
				if (ay*by < 0 && ax*abs(by) + bx*abs(ay))
					mq = true;
				if (otrp(r[j], r[j-1], Point(0, 0), Point(ox, oy)))
					eee = true;
			}
		}
		long long ax = r[p-1].x - ox, ay = r[p-1].y - oy, bx = r[0].x - ox, by = r[0].y - oy;
		if (ay*by < 0 && ax*abs(by) + bx*abs(ay))
			mq = true;
		if (otrp(r[0], r[p-1], Point(0, 0), Point(ox, oy)))
			eee = true;
		for (int j = 0; j < p; ++j)
			if (otrp(r[j], r[(j+2)%p], Point(0, 0), Point(ox, oy)))
				eee = true;
		std::sort(r, r + p);
	//	if (mq)
	//		std::cerr << "MQ\n";
	//	for (int j = 0; j < p; ++j)
	//		std::cerr << r[j].x << " " << r[j].y << "\n";
		Point np1 = r[0], np2 = r[p-1];
		long double pos1 = sqpos(np1), pos2 = sqpos(np2);
		if (pos1 > pos2)
			std::swap(pos1, pos2);
	//	std::cerr << np1.x << " " << np1.y << "   " << np2.x << " " << np2.y << "   " << pos1 << " " << pos2 << "\n";
		if (eee)
		{
	//		std::cerr << "EEE\n";
			--rez[(int)floor(pos1)];
			++cur;
			++rez[(int)floor(pos2)];
		} else {
			++rez[(int)floor(pos1)];
			--rez[(int)floor(pos2)];
		}
		if (ceil(pos1) == pos1)
			cantAdd[(int)ceil(pos1)] = true;
		if (ceil(pos2) == pos2)
			cantAdd[(int)ceil(pos2)] = true;
		mq = false;
	//	std::cerr << "--------------------------------------\n";
	}
	for (int i = 0; i < n*4; ++i)
	{
	//	std::cerr << i << " " << rez[i];
	//	if (cantAdd[i])
	//		std::cerr << " CANT";
		if (cur == 0 && !cantAdd[i])
		{
			++ru;
	//		std::cout << " +";
		}
		cur += rez[i];
	//	std::cerr << "\n";
	}
	std::cout << ru;
	return 0;
}
