#include <cstdio>
#include <iostream>
#include <cstdlib>

using namespace std;

struct point{
    double x, y;

    point(){}
    
    point(double _x, double _y){
	x = _x;
	y = _y;
    }
};

point operator * (point a, double x){
    return point(a.x * x, a.y * x);
}

point operator - (point a, point b){
    return point(a.x - b.x, a.y - b.y);
}

point operator + (point a, point b){
    return point(a.x + b.x, a.y + b.y);
}

double v_m(point a, point b){
    return a.x * b.y - a.y * b.x;
}

point o;
int n;
bool ok[4][2000000];
bool flag[4][2000000];
int sum[4][2000000];

void push(int i, int dir, int l, int r){
	int m = (l + r) / 2;
	flag[dir][i] = false;
	int x = ok[dir][i];
	ok[dir][2 * i + 1] = x;
	sum[dir][2 * i + 1] = (m - l) * x;
	flag[dir][2 * i + 1] = true;
	ok[dir][2 * i + 2] = x;
	sum[dir][2 * i + 2] = (r - m) * x;
	flag[dir][2 * i + 2] = true;
}

void insert(int x, int dir, int a, int b, int l, int r, int i){
	if (l >= a && r <= b){
		ok[dir][i] = x;
		sum[dir][i] = (r - l) * x;
		flag[dir][i] = true;
		return;
	}
	if (l >= b || r <= a){
		return;
	}
	if (flag[dir][i])
		push(i, dir, l, r);
	int m = (l + r) / 2;
	insert(x, dir, a, b, l, m, 2 * i + 1);
	insert(x, dir, a, b, m, r, 2 * i + 2);
	sum[dir][i] = sum[dir][2 * i + 1] + sum[dir][2 * i + 2];
}

int sign(double a){
	return (a > 0) - (a < 0);
}

pair<int, double> get(point a){
	point b;
	if (a.x - o.x > 0){
		b = o + (a - o) * (((double)n - o.x) / (a.x - o.x));
		if (b.y <= n && b.y >= 0){
			return make_pair(1, b.y);
		}
	}
	if (o.x - a.x > 0){
		b = o + (a - o) * (o.x / (o.x - a.x));
		if (b.y <= n && b.y >= 0){
			return make_pair(3, b.y);
		}
	}
	if (a.y - o.y > 0){
		b = o + (a - o) * (((double)n - o.y) / (a.y - o.y));
		if (b.x <= n && b.x >= 0){
			return make_pair(0, b.x);
		}
	}
	if (o.y - a.y > 0){
		b = o + (a - o) * (o.y / (o.y - a.y));
		if (b.x <= n && b.x >= 0){
			return make_pair(2, b.x);
		}
	}
}

point p[21];

int main(){
	int m;
	cin >> n >> m;
	cin >> o.x >> o.y;
	for (int i = 0; i < m; i++){
		int k;	
		cin >> k;
		for (int j = 0; j < k; j++)	
			cin >> p[j].x >> p[j].y;
		p[k] = p[0];	
		int b = 0;
		int j = 0;
		int s1 = sign(v_m(p[0] - o, p[1] - o));
		if (s1 == 0)
			s1 = 1;
		point r, l;	
		while (b < 2){		
			if (j == k)
				j = 0;
			int s2 = sign(v_m(p[j] - o, p[j + 1] - o));
			if (s1 == -s2){
				b++;
				s1 = s2;
				if (s2 == -1)
					r = p[j];	
				else
					l = p[j];
			}	
			j++;
		}
		pair<int, double> p = get(l);
		pair<int, double> q = get(r);
		if (p.first == q.first){
			int l1, r1;
			double l = p.second, r = q.second;			
			if (p.first == 1 || p.first == 2){
				l1 = (int) (l + 1.0 - 1e-7) - 1;
				r1 = (int) r - 1;
				insert(1, p.first, l1, r1 + 1, 0, n, 0);
			}
			else{
				swap(l, r);
				l1 = (int) (l + 1.0 - 1e-7);
				r1 = (int) r;
				insert(1, p.first, l1, r1 + 1, 0, n, 0);
			}		
		}
		else if ((q.first + 1) % 4 == p.first){
			int l1, r1;
			double l = p.second, r = q.second;			
			if (p.first == 1 || p.first == 2){
				l1 = (int) (l + 1.0 - 1e-7) - 1;
				insert(1, p.first, l1, n, 0, n, 0);
			}
			else{
				l1 = (int) l;
				insert(1, p.first, 0, l1 + 1, 0, n, 0);
			}
			if (q.first == 1 || q.first == 2){
				r1 = (int) r - 1;
				insert(1, q.first, 0, r1 + 1, 0, n, 0);
			}
			else{
				r1 = (int) (r + 1.0 - 1e-7);
				insert(1, q.first, r1, n, 0, n, 0);
			}	
		}
		else{
			int l1, r1;
			double l = p.second, r = q.second;			
			if (p.first == 1 || p.first == 2){
				l1 = (int) (l + 1.0 - 1e-7) - 1;
				insert(1, p.first, l1, n, 0, n, 0);
			}
			else{
				l1 = (int) l;
				insert(1, p.first, 0, l1 + 1, 0, n, 0);
			}
			if (q.first == 1 || q.first == 2){
				r1 = (int) r - 1;
				insert(1, q.first, 0, r1 + 1, 0, n, 0);
			}
			else{
				r1 = (int) (r + 1.0 - 1e-7);
				insert(1, q.first, r1, n, 0, n, 0);
			}	
			int m = (q.first + 1) % 4;
			insert(1, m, 0, n, 0, n, 0);
		}
	}
	int ans = 0;
	for (int i = 0; i < 4; i++){
		ans += sum[i][0];
	}
	ans = 4 * n - ans;
	cout << ans;
	return 0;
}
