#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const long long MAXT = 1500001;
const long long MAXX = 500001;
long long rgt[MAXT];
long long lft[MAXT];
long long t[500001];
long long x[500001];
long long w[500001];
long long p[500001];
long long sm[1500001];
long long ans[1500001];
long long c1[1500001];
long long c2[1500001];

bool cmp(long long a, long long b){
    return (t[a] < t[b]) || (t[a] == t[b] && x[a] < x[b]);
}

void set1(long long l, long long r, long long pos, long long x, long long i){
    if (l == r - 1){
        if (x > rgt[i])
            rgt[i] = x;
        return;
    }
    long long m = (l + r) / 2;
    if (m > pos){
        set1(l, m, pos, x, 2 * i + 1);
    }
    else{
        set1(m, r, pos, x, 2 * i + 2);
    }
    rgt[i] = max(rgt[2 * i + 1], rgt[2 * i + 2]);
}

void set2(long long l, long long r, long long pos, long long x, long long i){
    if (l == r - 1){
        if (x > lft[i])
            lft[i] = x;
        return;
    }
    long long m = (l + r) / 2;
    if (m > pos){
        set2(l, m, pos, x, 2 * i + 1);
    }
    else{
        set2(m, r, pos, x, 2 * i + 2);
    }
    lft[i] = max(lft[2 * i + 1], lft[2 * i + 2]);
}

long long getmr(long long l, long long r, long long ql, long long qr, long long i){
    if (l >= ql && r <= qr){
        return rgt[i];
    }
    if (l >= qr || r <= ql){
        return -1e9;
    }
    long long  m = (l + r) / 2;
    return max(getmr(l, m, ql, qr, 2 * i + 1), getmr(m, r, ql, qr, 2 * i + 2));
}

long long getml(long long l, long long r, long long ql, long long qr, long long i){
    if (l >= ql && r <= qr){
        return lft[i];
    }
    if (l >= qr || r <= ql){
        return -1e9;
    }
    long long  m = (l + r) / 2;
    return max(getml(l, m, ql, qr, 2 * i + 1), getml(m, r, ql, qr, 2 * i + 2));
}

long long n, u, d, s;

long long get(long long a, long long b){
    if (a < b) return (b - a) * u;
    return (a - b) * d;
}

int main()
{
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif
    cin >> n >> d >> u >> s;
    for (long long i = 0; i < n; i++){
        cin >> t[i] >> x[i] >> w[i];
        p[i] = i;
    }
    for (long long i = 0; i < MAXT; i++){
        rgt[i] = lft[i] = -1e9;
    }
    sort(p, p + n, cmp);
    /*bool b = true;
    for (long long i = 1; i < n; i++){
        if (x[p[i]] == x[p[i - 1]]) b = false;
    }
    if (b){
    set1(1, MAXX, s, -(d * s), 0);
    set2(1, MAXX, s, (u * s), 0);
    long long mx = 0;
    for (long long i = 0; i < n; i++){
        long long v = p[i];
        long long l = getml(1, MAXX, 1, x[v], 0);
        l += -(u * x[v]) + w[v];
        long long r = getmr(1, MAXX, x[v], MAXX, 0);
        r += (d * x[v]) + w[v];
        l = max(l, r);
        mx = max(mx, l - get(x[v], s));
        set1(1, MAXX, x[v], l - (d * x[v]), 0);
        set2(1, MAXX, x[v], l + (u * x[v]), 0);
    }
    cout << mx;
    return 0;
    }*/
    set1(1, MAXX, s, -(d * s), 0);
    set2(1, MAXX, s, (u * s), 0);
    long long mx = 0;
    for (int i = 0; i < n; i++){
        vector<int> cl;
        cl.push_back(p[i]);
        for (int j = i + 1; (j < n) && t[p[j]] == t[p[i]]; j++) cl.push_back(p[j]), i = j;
        sm[0] = 0;
        for (int i = 0; i < cl.size(); i++){
            sm[i + 1] = sm[i] + w[cl[i]];
            ans[i] = -1e9;
        }
        for (int j = 0; j < cl.size(); j++){
            long long l = getml(1, MAXX, 1, x[cl[j]], 0) - (u * x[cl[j]]);
            long long r = getmr(1, MAXX, x[cl[j]], MAXX, 0) + (d * x[cl[j]]);
            l = max(l, r);
            c1[j] = l - sm[j] + x[cl[j]] * u;
            c2[j] = l + sm[j + 1] - x[cl[j]] * d;
            /*for (int k = 0; k < cl.size(); k++){
                long long l =
                l += -(u * x[cl[j]]) + sm[max(j, k) + 1] - sm[min(j, k)] - get(x[cl[j]], x[cl[k]]);
                long long r = getmr(1, MAXX, x[cl[j]], MAXX, 0);
                r += (d * x[cl[j]]) + sm[max(j, k) + 1] - sm[min(j, k)] - get(x[cl[j]], x[cl[k]]);
                l = max(l, r);
                mx = max(mx, l - get(x[cl[k]], s));
                ans[k] = max(ans[k], l);
            }*/
        }
        long long mxc = -1e9;
        for (int j = 0; j < cl.size(); j++){
            mxc = max(mxc, c1[j]);
            ans[j] = max(ans[j], mxc + sm[j + 1] - x[cl[j]] * u);
        }
        mxc = -1e9;
        for (int j = cl.size() - 1; j >= 0; j--){
            mxc = max(mxc, c2[j]);
            ans[j] = max(ans[j], mxc - sm[j] + x[cl[j]] * d);
        }
        for (int j = 0; j < cl.size(); j++){
            mx = max(mx, ans[j] - get(x[cl[j]], s));
            set1(1, MAXX, x[cl[j]], ans[j] - (d * x[cl[j]]), 0);
            set2(1, MAXX, x[cl[j]], ans[j] + (u * x[cl[j]]), 0);
        }
    }
    cout << mx;
    return 0;
}
