#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;
const int MAXN = 100002;
int rmq[MAXN * 4];
pair <int, int> a[MAXN];

int lz, rz, mh;

void modify_rmq(int v = 0, int l = 1, int r = mh)
{
	if ((lz > r) || (l > rz)) return;
	if ((lz <= l) && (r <= rz))
	{
		rmq[v]++;
		return;
	}
	int md = (l + r) / 2;
	modify_rmq(v * 2 + 1, l, md);
	modify_rmq(v * 2 + 2, md + 1, r);
}

int get_val(int v = 0, int l = 1, int r = mh)
{
	if (l == r) return rmq[v];
	int md = (l + r) / 2;
	if (lz > md) return rmq[v] + get_val(v * 2 + 2, md + 1, r);
	else return rmq[v] + get_val(v * 2 + 1, l, md);
}

int bs(int val)
{
	int l = 1, r = mh + 1;
	while (l < r)
	{
		int md = (l + r) / 2;
		lz = md;
		if (get_val() > val) l = md + 1;
		else r = md;
	}
	return l;
}

int main()
{
	for (int i = 0; i < MAXN * 4; i++) rmq[i] = 0;
	int n;
	cin >> n;
	mh = 0;
	for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second, mh = max(mh, a[i].first);
	sort(a, a + n);
	for (int i = 0; i < n; i++)
	{
		lz = a[i].first - a[i].second + 1;

		int dd = get_val();
		int g1 = bs(dd - 1), g2 = bs(dd);
		lz = g1, rz = a[i].first;
		if (lz <= rz)
		{
			modify_rmq();
    		lz = g2, rz = g2 + a[i].second - (a[i].first - g1) - 2;
	    	modify_rmq();
		}
		else
		{
			lz = g2, rz = g2 + a[i].second - 1;
			modify_rmq();
		}
	}
	long long res = 0;
	for (lz = 1; lz <= mh; lz++)
	{
		long long cc = get_val();
		res += (cc * (cc - 1)) / 2;
	}
	cout << res << endl;
	return 0;
}