#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 801;
const int INF = 1000 * 1001;
const int INF2 = 1002 * 1001 * 1000;
string a[MAXN];
int b[MAXN][MAXN];
int d[MAXN][MAXN];
int qx[MAXN * MAXN], qy[MAXN * MAXN], qb, qe;

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, s;
	cin >> n >> s;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	int sx, sy, fx, fy;
	qb = 0, qe = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (a[i][j] != 'H') b[i][j] = INF;
			else
			{
				b[i][j] = 0;
				qx[qe] = i;
				qy[qe++] = j;
			}
			if (a[i][j] == 'M') sx = i, sy = j;
	    	if (a[i][j] == 'D') fx = i, fy = j;
		}
	}
	while (qb < qe)
	{
		int cx = qx[qb], cy = qy[qb];
		qb++;
		if ((cx > 0) && ((a[cx - 1][cy] == 'G') || (a[cx - 1][cy] == 'M')) && (b[cx - 1][cy] == INF))
		{
			b[cx - 1][cy] = b[cx][cy] + 1;
			qx[qe] = cx - 1;
			qy[qe] = cy;
			qe++;
		}
		if ((cx < n - 1) && ((a[cx + 1][cy] == 'G') || (a[cx + 1][cy] == 'M')) && (b[cx + 1][cy] == INF))
		{
			b[cx + 1][cy] = b[cx][cy] + 1;
			qx[qe] = cx + 1;
			qy[qe] = cy;
			qe++;
		}
		if ((cy > 0) && ((a[cx][cy - 1] == 'G') || (a[cx][cy - 1] == 'M')) && (b[cx][cy - 1] == INF))
		{
			b[cx][cy - 1] = b[cx][cy] + 1;
			qx[qe] = cx;
			qy[qe] = cy - 1;
			qe++;
		}
		if ((cy < n - 1) && ((a[cx][cy + 1] == 'G') || (a[cx][cy + 1] == 'M')) && (b[cx][cy + 1] == INF))
		{
			b[cx][cy + 1] = b[cx][cy] + 1;
			qx[qe] = cx;
			qy[qe] = cy + 1;
			qe++;
		}
	}	
	int l = -1, r = b[sx][sy] - 1;
	while (l < r)
	{
		int md = (l + r + 1) / 2;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				d[i][j] = INF2;
			}
		}
		d[sx][sy] = md * s;
		qb = 0, qe = 1;
		qx[0] = sx, qy[0] = sy;
		while (qb < qe)
		{
			int cx = qx[qb], cy = qy[qb];
			qb++;
			if ((cx != 0) && (a[cx - 1][cy] != 'T') && (d[cx][cy] + 1 < b[cx - 1][cy] * s) && (d[cx - 1][cy] == INF2))
			{
				d[cx - 1][cy] = d[cx][cy] + 1;
				qx[qe] = cx - 1;
				qy[qe] = cy;
				qe++;
			}
			if ((cx != n - 1) && (a[cx + 1][cy] != 'T') && (d[cx][cy] + 1 < b[cx + 1][cy] * s) && (d[cx + 1][cy] == INF2))
			{
				d[cx + 1][cy] = d[cx][cy] + 1;
				qx[qe] = cx + 1;
				qy[qe] = cy;
				qe++;
			}
			if ((cy != 0) && (a[cx][cy - 1] != 'T') && (d[cx][cy] + 1 < b[cx][cy - 1] * s) && (d[cx][cy - 1] == INF2))
			{
				d[cx][cy - 1] = d[cx][cy] + 1;
				qx[qe] = cx;
				qy[qe] = cy - 1;
				qe++;
			}
			if ((cy != n - 1) && (a[cx][cy + 1] != 'T') && (d[cx][cy] + 1 < b[cx][cy + 1] * s) && (d[cx][cy + 1] == INF2))
			{
				d[cx][cy + 1] = d[cx][cy] + 1;
				qx[qe] = cx;
				qy[qe] = cy + 1;
				qe++;
			}
			if (d[fx][fy] != INF2) l = md;
			else r = md - 1;
		}
	}
	cout << l << endl;
	return 0;
}