#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXR = 5011;
const int MAXC = 211;
const int MAXLOG = 15;
const int PARTITION = 10;
const int INF = 1000 * 1000 * 10;

struct matrix
{
	int t[200][200];
};

vector <matrix> e[MAXR / PARTITION];
int ps;
int es[MAXR / PARTITION];
int r, c;
int h[5000][200], v[5000][200];
int sm[MAXC];

void assign(matrix &a, matrix b)
{
	for (int i = 0; i < c; i++)
	{
		for (int j = 0; j < c; j++)
		{
			a.t[i][j] = b.t[i][j];
		}
	}
}

int bs[201][201];
void conc(matrix a, matrix b, matrix& res)
{
	for (int i = 0; i < c; i++)
	{
		int bp = 0;
		for (int j = 1; j < c; j++)
		{
			if (a.t[i][j] + b.t[j][i] < a.t[i][bp] + b.t[bp][i]) bp = j;
		}
		bs[i][i] = bp;
		res.t[i][i] = a.t[i][bp] + b.t[bp][i];
	}
	for (int d = 1; d < c; d++)
	{
		for (int i = 0; i < c - d; i++)
		{
			int j = i + d;
			int bp = bs[i + 1][j];
			for (int l = bs[i][j - 1]; l < bs[i + 1][j]; l++)
			{
				if (a.t[i][l] + b.t[l][j] < a.t[i][bp] + b.t[bp][j]) bp = l;
			}
			res.t[i][j] = a.t[i][bp] + b.t[bp][j];
			bs[i][j] = bp;
			bp = bs[j][i + 1];
			for (int l = bs[j - 1][i]; l < bs[j][i + 1]; l++)
			{
				if (a.t[j][l] + b.t[l][i] < a.t[j][bp] + b.t[bp][i]) bp = l;
			}
			res.t[j][i] = a.t[j][bp] + b.t[bp][i];
			bs[j][i] = bp;
		}
	}
}

void calc(int id)
{
	matrix cm;
	for (int i = 0; i < c; i++)
	{
		for (int j = 0; j < c; j++)
		{
			cm.t[i][j] = INF;
		}
		cm.t[i][i] = 0;
	}
	matrix cm2;
	for (int i = id * PARTITION; i < min(r - 1, (id + 1) * PARTITION); i++)
	{
		sm[0] = 0;
		for (int j = 0; j < c - 1; j++)
		{
			sm[j + 1] = sm[j] + h[i][j];
		}
		for (int j = 0; j < c; j++)
		{
			for (int l = 0; l < c; l++)
			{
				cm2.t[j][l] = abs(sm[j] - sm[l]) + v[i][l];
			}
		}
		conc(cm, cm2, cm);
	}
	assign(e[id][0], cm);
}

void init(int R, int C, int H[5000][200], int V[5000][200])
{
	/*r = R + 1;
	c = C;
	for (int i = 0; i < 5000; i++)
	{
		for (int j = 0; j < 200; j++)
		{
			h[i][j] = H[i][j];
			v[i][j] = V[i][j];
		}
	}
	ps = ((r - 2) / PARTITION + 1);
	for (int i = 0; i < c; i++)
	{
		v[r - 1][i] = 0;
	}
	es[0] = 0;
	while (ps > (1 << es[0])) es[0]++;
	es[0]++;
	for (int i = 1; i < ps; i++)
	{
		int s2 = 0;
		while (i % (1 << s2) == 0)  s2++;
		es[i] = s2;
	}
	for (int i = 0; i < ps; i++)
	{
		e[i].resize(es[i]);
		calc(i);
	}
	
	for (int i = ps - 1; i >= 0; i--)
	{
		for (int j = 1; j < es[i]; j++)
		{
			if (i + (1 << j - 1) < ps) conc(e[i][j - 1], e[i + (1 << (j - 1))][j - 1], e[i][j]);
			else assign(e[i][j], e[i][j - 1]);
		}
	}*/
}

void changeH(int P, int Q, int W)
{
	h[P][Q] = W;
	P /= PARTITION;
	calc(P);
	for (int i = 1; i < es[0]; i++)
	{
		int ve = (P / (1 << i) * (1 << i));
		if (ve + (1 << (i - 1)) < ps) conc(e[ve][i - 1], e[ve + (1 << (i - 1))][i - 1], e[ve][i]);
		else assign(e[ve][i], e[ve][i - 1]);
	}
}

void changeV(int P, int Q, int W)
{
	v[P][Q] = W;
	P /= PARTITION;
	calc(P);
	for (int i = 1; i < es[0]; i++)
	{
		int ve = (P / (1 << i) * (1 << i));
		if (ve + (1 << (i - 1)) < ps) conc(e[ve][i - 1], e[ve + (1 << (i - 1))][i - 1], e[ve][i]);
		else assign(e[ve][i], e[ve][i - 1]);
	}
}

int escape(int V1, int V2)
{
	return e[0][es[0] - 1].t[V1][V2];
}