#include <iostream>
#include <string>
#include <vector>

const int N = 25555;

struct Node
{
	bool word;
	int last;
	int next[26];
} tree[N * 22];
int nc = 0;

int newNode()
{
	memset(tree[nc].next, -1, sizeof(tree[nc].next));
	tree[nc].last = -1;
	return nc++;
}

void addWord(const std::string & s)
{
	int c = 0;
	for (int i = 0; i < s.length(); ++i)
	{
		if (tree[c].next[s[i] - 'a'] == -1)
			tree[c].next[s[i] - 'a'] = newNode();
		c = tree[c].next[s[i] - 'a'];
	}
	tree[c].word = true;
}

std::string longest;
int ost;

std::vector < char > answer;

bool dfs(int v = 0)
{
	if (tree[v].word)
	{
		answer.push_back('P');
		if (--ost == 0)
			return false;
	}
	for (int i = 0; i < 26; ++i)
		if (i != tree[v].last && tree[v].next[i] != -1)
		{
			answer.push_back('a' + i);
			if (!dfs(tree[v].next[i]))
				return false;
			answer.push_back('-');
		}
	if (tree[v].last != -1)
	{
		answer.push_back('a' + tree[v].last);
		if (!dfs(tree[v].next[tree[v].last]))
			return false;
		answer.push_back('-');
	}
	return true;
}

int main()
{
	newNode();
	int n;
	std::cin >> n;
	for (int i = 0; i < n; ++i)
	{
		std::string s;
		std::cin >> s;
		addWord(s);
		if (s.length() > longest.length())
			longest = s;
	}
	int c = 0;
	for (int i = 0; i < longest.length(); ++i)
		c = tree[c].next[tree[c].last = longest[i] - 'a'];
	ost = n;
	dfs(0);
	std::cout << answer.size() << "\n";
	for (int i = 0; i < answer.size(); ++i)
		std::cout << answer[i] << "\n";
	return 0;
}