#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 200001;
long long x[MAXN];
long long y[MAXN];
int c[MAXN];
int id[MAXN];
vector <int> pos;
vector <pair <int, int> > ans;
vector <int> vt1, vt2, vt3;

long long vect(long long x1, long long y1, long long x2, long long y2)
{
	return x1 * y2 - x2 * y1;
}
bool chck(int p1, int p2, int p3, int cur)
{
	long long v1 = vect(x[p1] - x[cur], y[p1] - y[cur], x[p2] - x[cur], y[p2] - y[cur]);
	long long v2 = vect(x[p2] - x[cur], y[p2] - y[cur], x[p3] - x[cur], y[p3] - y[cur]);
	long long v3 = vect(x[p3] - x[cur], y[p3] - y[cur], x[p1] - x[cur], y[p1] - y[cur]);
	return (abs(v1 + v2 + v3) == abs(v1) + abs(v2) + abs(v3));
}

void go(int p1, int p2, int p3, int lg, int rg)
{
	pos.clear();
	for (int i = lg; i <= rg; i++)
	{
		if (c[id[i]] == c[p3])
		{
			pos.push_back(i);
		}
	}
	if (pos.size() == 0)
	{
		for (int i = lg; i <= rg; i++)
		{
			ans.push_back(make_pair(p1, id[i]));
		}
	}
	else
	{
		int id4 = pos[rand() % pos.size()];
		int p4 = id[id4];
		ans.push_back(make_pair(p3, p4));
		vt1.clear();
		vt2.clear();
		vt3.clear();
		for (int i = lg; i <= rg; i++)
		{
			if (i == id4) continue;
			if (chck(p1, p2, p4, id[i])) vt1.push_back(id[i]);
			else if (chck(p3, p4, p1, id[i])) vt2.push_back(id[i]);
			else vt3.push_back(id[i]);
		}
		id[lg] = id4;
		int s1 = lg + 1, s2 = lg + 1 + vt1.size(), s3 = lg + 1 + vt1.size() + vt2.size(); 
		for (int i = 0; i < vt1.size(); i++) id[s1 + i] = vt1[i];
		for (int i = 0; i < vt2.size(); i++) id[s2 + i] = vt2[i];
		for (int i = 0; i < vt3.size(); i++) id[s3 + i] = vt3[i];
		go(p1, p2, p4, s1, s2 - 1);
		go(p3, p4, p1, s2, s3 - 1);
		go(p3, p4, p2, s3, rg);
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int g, r;
	cin >> g;
	for (int i = 0; i < g; i++) cin >> x[i] >> y[i], c[i] = 0, id[i] = i;
	cin >> r;
	for (int i = 0; i < r; i++) cin >> x[i + g] >> y[i + g], c[i + g] = 1, id[i + g] = i + g;
	ans.push_back(make_pair(0, 1));
	ans.push_back(make_pair(g, g + 1));
	swap(id[2], id[g]);
	swap(id[3], id[g + 1]);
	vt1.clear(), vt2.clear();
	for (int i = 4; i < g + r; i++)
	{
		if (chck(0, 1, g, id[i])) vt1.push_back(id[i]);
		else vt2.push_back(id[i]);
	}
	int v1 = vt1.size();
	for (int i = 0; i < vt1.size(); i++) id[i + 4] = vt1[i];
	for (int i = 0; i < vt2.size(); i++) id[i + 4 + v1] =  vt2[i];
	go(0, 1, g, 4, 4 + v1 - 1);
	go(g, g + 1, 1, 4 + v1, g + r - 1);
	for (int i = 0; i < ans.size(); i++)
	{
		if (c[ans[i].first] == 0) cout <<ans[i].first + 1 << " " << ans[i].second + 1 << " g" << endl;
		else cout << ans[i].first - g + 1 << " " << ans[i].second - g + 1 << " r" <<  endl;
	}
	return 0;
}