#include "grader.h"
#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

ll gcd(ll a, ll b)
{
    return b ? gcd(b, a%b) : a;
}

const int N = 1 << 30;

class SegTree
{
private:
    struct Node
    {
        int l, r;
        ll val;
    };
    static Node nodes[20000000];
    static int nodesCount;
    static int newNode()
    {
        nodes[nodesCount].l = nodes[nodesCount].r = -1;
        nodes[nodesCount].val = 0;
        return nodesCount++;
    }
    int root;
public:
    SegTree() : root(newNode()) {}

    void set(int pos, ll x)
    {
        int curr = root;
        int cl = 0, cr = N - 1;
        static vector < int > stk;
        stk.clear();
        while (cl != cr)
        {
            stk.push_back(curr);
            int mid = (cl+cr)>>1;
            if (pos <= mid)
            {
                if (nodes[curr].l == -1)
                    nodes[curr].l = newNode();
                curr = nodes[curr].l;
                cr = mid;
            } else {
                if (nodes[curr].r == -1)
                    nodes[curr].r = newNode();
                curr = nodes[curr].r;
                cl = mid + 1;
            }
        }
        nodes[curr].val = x;
        for (int i = sz(stk)-1; i >= 0; --i)
        {
            curr = stk[i];
            nodes[curr].val = gcd((nodes[curr].l?nodes[nodes[curr].l].val:0), (nodes[curr].r?nodes[nodes[curr].r].val:0));
        }
    }

private:
    ll get(int l, int r, int c, int cl, int cr)
    {
        if (c == -1 || l > cr || r < cl)
            return 0;
        if (l <= cl && cr <= r)
            return nodes[c].val;
        int mid = (cl+cr) >> 1;
        return gcd(get(l, r, nodes[c].l, cl, mid), get(l, r, nodes[c].r, mid+1, cr));
    }

public:
    ll get(int l, int r)
    {
        return get(l, r, root, 0, N-1);
    }

    ll get(int pos)
    {
        int curr = root;
        int cl = 0, cr = N - 1;
        while (cl != cr)
        {
            int mid = (cl+cr)>>1;
            if (pos <= mid)
            {
                if (nodes[curr].l == -1)
                    return 0;
                curr = nodes[curr].l;
                cr = mid;
            } else {
                if (nodes[curr].r == -1)
                    return 0;
                curr = nodes[curr].r;
                cl = mid + 1;
            }
        }
        return nodes[curr].val;
    }
};
SegTree::Node SegTree::nodes[20000000];
int SegTree::nodesCount = 0;

class SegTree2d
{
private:
    struct Node
    {
        Node * l, * r, * p;
        SegTree val;
        Node(Node * np = nullptr) : l(nullptr), r(nullptr), p(np) {}
    } * root;
public:
    SegTree2d() : root(new Node) {}

    void set(int pos, int pos2, ll x)
    {
        Node * curr = root;
        int cl = 0, cr = N - 1;
        static vector < Node * > stk;
        stk.clear();
        while (cl != cr)
        {
            stk.push_back(curr);
            int mid = (cl+cr)>>1;
            if (pos <= mid)
            {
                if (curr->l == nullptr)
                    curr->l = new Node();
                curr = curr->l;
                cr = mid;
            } else {
                if (curr->r == nullptr)
                    curr->r = new Node();
                curr = curr->r;
                cl = mid + 1;
            }
        }
        curr->val.set(pos2, x);
        for (int i = sz(stk)-1; i >= 0; --i)
        {
            curr = stk[i];
            curr->val.set(pos2, gcd((curr->l?curr->l->val.get(pos2):0), (curr->r?curr->r->val.get(pos2):0)));
        }
    }

private:
    ll get(int l, int r, int l2, int r2, Node * c, int cl, int cr)
    {
        if (c == nullptr || l > cr || r < cl)
            return 0;
        if (l <= cl && cr <= r)
            return c->val.get(l2, r2);
        int mid = (cl+cr) >> 1;
        return gcd(get(l, r, l2, r2, c->l, cl, mid), get(l, r, l2, r2, c->r, mid+1, cr));
    }

public:
    ll get(int l, int r, int l2, int r2)
    {
        return get(l, r, l2, r2, root, 0, N-1);
    }
} st2d;

void init(int, int)
{
}

void update(int x, int y, long long t)
{
    st2d.set(x, y, t);
}

long long calculate(int xl, int yl, int xr, int yr)
{
    return st2d.get(xl, xr, yl, yr);
}
