#include "grader.h"
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 150001;
const int GROUPS = 320;
vector <int> a[MAXN];
vector <int> ans1[MAXN];
vector <int> ans2[MAXN];
int n, l, g;
int x[MAXN];
int tmp[MAXN];

void count(int id)
{
	int n2 = a[id].size();
	ans1[id].resize(n2);
	ans2[id].resize(n2);
	int p = n2 - 1;
	for (int i = n2 - 1; i >= 0; i--)
	{
		while (a[id][p] - a[id][i] > l) p--;
		if (p == n2 - 1)
		{
			ans1[id][i] = 1;
			ans2[id][i] = a[id][i] + l;
		}
		else
		{
			ans1[id][i] = ans1[id][p + 1] + 1;
			ans2[id][i] = ans2[id][p + 1];
		}
	}
}

bool del(int id, int val)
{
	int r = -1;
	for (int i = 0; i < a[id].size(); i++)
	{
		if (a[id][i] == val)
		{
			r = i;
			break;
		}
	}
	if (r == -1) return false;
	for (int i = r + 1; i < a[id].size(); i++)
	{
		a[id][i - 1] = a[id][i];
	}
	a[id].pop_back();
	count(id);
	return true;
}

void add(int id, int val)
{
	int r = a[id].size();
	for (int i = 0; i < a[id].size(); i++)
	{
		if (a[id][i] > val)
		{
			r = i;
			break;
		}
	}
	a[id].resize(a[id].size() + 1);
	for (int i = a[id].size() - 1; i > r; i--)
	{
		a[id][i] = a[id][i - 1];
	}
	a[id][r] = val;
	count(id);
}

int fnd(int val)
{
	for (int i = 1; i < g; i++)
	{
		if (a[i][0] > val) return i - 1;
	}
	return g - 1;
}

void calc()
{
	for (int i = 0; i < n; i++)
	{
		tmp[i] = x[i];
	}
	sort(tmp, tmp + n);
	for (int i = 0; i < g; i++)
	{
		a[i].clear();
		for (int j = i * GROUPS; j < min((i + 1) * GROUPS, n); j++)
		{
			a[i].push_back(tmp[j]);
		}
		count(i);
	}
}

int oss = 0;

void init(int N, int L, int X[])
{
	n = N;
	l = L;
	oss = 0;
	g = (n - 1) / GROUPS + 1;
	for (int i = 0; i < n; i++) x[i] = X[i];
	calc();
}

int bb(int id, int v)
{
	int lg = 0, rg = a[id].size();
	while (lg < rg)
	{
		int md = (lg + rg) / 2;
		if (a[id][md] > v) rg = md;
		else lg = md + 1;
	}
	return lg;
}

int update(int j, int y)
{
	oss++;
	for (int i = 0; i < g; i++)
	{
		if (del(i, x[j])) break;
	}
	add(fnd(y), y);
	x[j] = y;
	if (oss = GROUPS) calc(), oss = 0;
	int rs = 0, c = -1;
	for (int i = 0; i < g; i++)
	{
		int cur = bb(i, c);
		if (cur == a[i].size()) continue;
		rs += ans1[i][cur];
		c = ans2[i][cur];
	}
	return rs;
}
