#include "grader.h"  
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

//#include "grader.h"

const int N = 1000111;
const int INF = 2000000008;

int narr[N*2], *near[N], ncount[N], ncurr[N];
struct Node
{
	int num;
	int par;
	int bcount, btpc, maxd;
} nodes[N];
int nc, bc, minn, mino = 0;

int LocateCentre(int n, int pp[], int S[], int D[])
{
	memset(ncount, 0, sizeof(ncount));
	memset(ncurr, 0, sizeof(ncurr));
	memset(nodes, 0, sizeof(nodes));
	minn = INF;
	bc = 0;
	for (int i = 0; i < n-1; ++i)
	{
		++ncount[S[i]];
		++ncount[D[i]];
	}
	near[0] = narr;
	for (int i = 1; i < n; ++i)
		near[i] = near[i - 1] + ncount[i - 1];
	for (int i = 0; i < n-1; ++i)
	{
		near[S[i]][ncurr[S[i]]++] = D[i];
		near[D[i]][ncurr[D[i]]++] = S[i];
	}
	nodes[0].num = 0;
	nodes[0].par = -1;
	nc = 1;
	for (int i = 0; i < n; ++i)
	{
		bc += pp[i];
		int v = nodes[i].num;
		for (int j = 0; j < ncount[v]; ++j)
			if (near[v][j] != nodes[nodes[i].par].num)
			{
				nodes[nc].num = near[v][j];
				nodes[nc].par = i;
				++nc;
			}
	}
	for (int i = n-1; i >= 0; --i)
	{
		nodes[i].bcount += pp[nodes[i].num];
		int p = nodes[i].par;
		if (p != -1)
		{
			nodes[p].bcount += nodes[i].bcount;
			if (nodes[p].maxd < nodes[i].bcount)
				nodes[p].maxd = nodes[i].bcount;
		}
	}
	for (int i = n-1; i >= 0; --i)
	{
		nodes[i].btpc = bc - nodes[i].bcount;
		nodes[i].maxd = std::max(nodes[i].maxd, nodes[i].btpc);
		if (nodes[i].maxd < minn)
		{
			minn = nodes[i].maxd;
			mino = nodes[i].num;
		}
	}
	return mino;
}
