#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef double dl;
const int INF = 1e9;
char a[802][802];
int n, s, beefs[802][802], sti, stj, fi, fj, b[802][802];
vector<pair<int, int> > bees;
void befs(int sti, int stj){
    queue<pair<int, int> > q;
    q.push(make_pair(sti, stj));
    beefs[sti][stj] = 0;
    while(!q.empty()){
        int i = q.front().first, j = q.front().second;
        q.pop();
        if (a[i - 1][j] != 'T' && a[i - 1][j] != 'D' && beefs[i][j] + 1 < beefs[i - 1][j]){
            beefs[i - 1][j] = beefs[i][j] + 1;
            q.push(make_pair(i - 1, j));
        }
        if (a[i + 1][j] != 'T' && a[i + 1][j] != 'D' && beefs[i][j] + 1 < beefs[i + 1][j]){
            beefs[i + 1][j] = beefs[i][j] + 1;
            q.push(make_pair(i + 1, j));
        }
        if (a[i][j - 1] != 'T' && a[i][j - 1] != 'D' && beefs[i][j] + 1 < beefs[i][j - 1]){
            beefs[i][j - 1] = beefs[i][j] + 1;
            q.push(make_pair(i, j - 1));
        }
        if (a[i][j + 1] != 'T' && a[i][j + 1] != 'D' && beefs[i][j] + 1 < beefs[i][j + 1]){
            beefs[i][j + 1] = beefs[i][j] + 1;
            q.push(make_pair(i, j + 1));
        }
    }
}
int penalty(int x){
    return (x + s - 1) / s;
}
bool bfs(int pen){
    if (pen >= beefs[sti][stj])
        return 0;
    queue<pair<int, int> > q;
    q.push(make_pair(sti, stj));
    for (int i = 0; i <= n + 1; i++)
        for(int j = 0; j <= n + 1; j++)
            b[i][j] = INF;
    b[sti][stj] = 0;
    while(!q.empty() && b[fi][fj] == INF){
        int i = q.front().first, j = q.front().second;
        int x = penalty(b[i][j] + 1) + pen;
        q.pop();
        if (a[i - 1][j] != 'T' && b[i][j] + 1 < b[i - 1][j] && (x < beefs[i - 1][j] || (x == beefs[i - 1][j] && ((b[i][j] + 1) % s != 0 || ((b[i][j] + 1) % s == 0 && i == fi && j == fj))))){
            b[i - 1][j] = b[i][j] + 1;
            q.push(make_pair(i - 1, j));
        }
        if (a[i + 1][j] != 'T' && b[i][j] + 1 < b[i + 1][j] && (x < beefs[i + 1][j] || (x == beefs[i + 1][j] && ((b[i][j] + 1) % s != 0 || ((b[i][j] + 1) % s == 0 && i == fi && j == fj))))){
            b[i + 1][j] = b[i][j] + 1;
            q.push(make_pair(i + 1, j));
        }
        if (a[i][j - 1] != 'T' && b[i][j] + 1 < b[i][j - 1] && (x < beefs[i][j - 1] || (x == beefs[i][j - 1] && ((b[i][j] + 1) % s != 0 || ((b[i][j] + 1) % s == 0 && i == fi && j == fj))))){
            b[i][j - 1] = b[i][j] + 1;
            q.push(make_pair(i, j - 1));
        }
        if (a[i][j + 1] != 'T' && b[i][j] + 1 < b[i][j + 1] && (x < beefs[i][j + 1] || (x == beefs[i][j + 1] && ((b[i][j] + 1) % s != 0 || ((b[i][j] + 1) % s == 0 && i == fi && j == fj))))){
            b[i][j + 1] = b[i][j] + 1;
            q.push(make_pair(i, j + 1));
        }
    }
    return b[fi][fj] != INF;
}
int main()
{
    //ifstream cin("a.in");
    //ofstream cout("a.out");
    ios::sync_with_stdio(false);
    cin >> n >> s;
    for (int i = 0; i <= n + 1; i++)
        a[i][0] = 'T', a[i][n + 1] = 'T', a[0][i] = 'T', a[n + 1][i] = 'T',
        beefs[i][0] = INF, beefs[i][n + 1] = INF, beefs[0][i] = INF, beefs[n + 1][i] = INF;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++){
            cin >> a[i][j];
            beefs[i][j] = INF;
            if (a[i][j] == 'M')
                sti = i, stj = j;
            if (a[i][j] == 'D')
                fi = i, fj = j;
            if (a[i][j] == 'H')
                bees.push_back(make_pair(i, j));
        }
    for (int i = 0; i < (int)bees.size(); i++)
        befs(bees[i].first, bees[i].second);
    int l = -1, r = INF;
    while(r - l > 1){
        int m = (l + r) / 2;
        if(bfs(m))
            l = m;
        else
            r = m;
    }
    cout << l;
}
