#include "grader.h"
#include <bits/stdc++.h>

typedef long long ll;

ll gcd2(ll x, ll y)
{
    return y ? gcd2(y, x % y) : x;
}

struct Node2
{
    Node2 * nl, * nr;
    int l, r;
    ll v;

    void set(int p, ll x)
    {
        if (r == l + 1)
        {
            v = x;
            return;
        }
        int m = (l + r) >> 1;
        if (nl == nullptr)
        {
            nl = new Node2;
            nl->nl = nl->nr = nullptr;
            nl->l = l;
            nl->r = m;
            nl->v = 0;
        }
        if (nr == nullptr)
        {
            nr = new Node2;
            nr->nl = nl->nr = nullptr;
            nr->l = m;
            nr->r = r;
            nr->v = 0;
        }
        if (p < m)
            nl->set(p, x);
        else
            nr->set(p, x);
        v = gcd2(nl->v, nr->v);
    }
};

ll getGCD2(Node2 * n, int l, int r)
{
    if (n == nullptr || r <= n->l || n->r <= l)
        return 0;
    if (l <= n->l && n->r <= r)
        return n->v;
    return gcd2(getGCD2(n->nl, l, r), getGCD2(n->nr, l, r));
}

struct Node1
{
    Node1 * nl, * nr;
    int l, r;
    Node2 * v;

    void set(int p, int p1, ll x)
    {
        if (v == nullptr)
        {
            v = new Node2;
            v->nl = v->nr = nullptr;
            v->l = 0;
            v->r = 1 << 30;
            v->v = 0;
        }
        if (r == l + 1)
        {
            v->set(p1, x);
            return;
        }
        int m = (l + r) >> 1;
        if (nl == nullptr)
        {
            nl = new Node1;
            nl->nl = nl->nr = nullptr;
            nl->l = l;
            nl->r = m;
            nl->v = 0;
        }
        if (nr == nullptr)
        {
            nr = new Node1;
            nr->nl = nl->nr = nullptr;
            nr->l = m;
            nr->r = r;
            nr->v = 0;
        }
        if (p < m)
            nl->set(p, p1, x);
        else
            nr->set(p, p1, x);
        v->set(p1, gcd2(getGCD2(nl->v, p1, p1 + 1), getGCD2(nr->v, p1, p1 + 1)));
    }
};

ll getGCD1(Node1 * n, int l, int r, int l2, int r2)
{
    if (n == nullptr || r <= n->l || n->r <= l)
        return 0;
    if (l <= n->l && n->r <= r)
        return getGCD2(n->v, l2, r2);
    return gcd2(getGCD1(n->nl, l, r, l2, r2), getGCD1(n->nr, l, r, l2, r2));
}

Node1 * root;

void init(int r, int c)
{
    root = new Node1;
    root->nl = root->nr = nullptr;
    root->v = nullptr;
    root->l = 0;
    root->r = 1 << 30;
}

void update(int x, int y, long long t)
{
    root->set(x, y, t);
}

long long calculate(int xl, int yl, int xr, int yr)
{
    return getGCD1(root, xl, xr + 1, yl, yr + 1);
}
