#include "grader.h"
#include <bits/stdc++.h>

typedef long long ll;

ll gcd2(ll x, ll y)
{
    return y ? gcd2(y, x % y) : x;
}

struct Node2
{
    Node2 * nl, * nr;
    ll v;

    void set(int p, ll x, int cl = 0, int cr = 1 << 30)
    {
        if (cr == cl + 1)
        {
            v = x;
            return;
        }
        int m = (cl + cr) >> 1;
        if (nl == nullptr)
        {
            nl = new Node2;
            nl->nl = nl->nr = nullptr;
            nl->v = 0;
        }
        if (nr == nullptr)
        {
            nr = new Node2;
            nr->nl = nl->nr = nullptr;
            nr->v = 0;
        }
        if (p < m)
            nl->set(p, x, cl, m);
        else
            nr->set(p, x, m, cr);
        v = gcd2(nl->v, nr->v);
    }
};

ll getGCD2(Node2 * n, int l, int r, int cl = 0, int cr = 1 << 30)
{
    if (n == nullptr || r <= cl || cr <= l)
        return 0;
    if (l <= cl && cr <= r)
        return n->v;
    int m = (cl + cr) >> 1;
    return gcd2(getGCD2(n->nl, l, r, cl, m), getGCD2(n->nr, l, r, m, cr));
}

struct Node1
{
    Node1 * nl, * nr;
    Node2 * v;

    void set(int p, int p1, ll x, int cl = 0, int cr = 1 << 30)
    {
        if (v == nullptr)
        {
            v = new Node2;
            v->nl = v->nr = nullptr;
            v->v = 0;
        }
        if (cr == cl + 1)
        {
            v->set(p1, x);
            return;
        }
        int m = (cl + cr) >> 1;
        if (nl == nullptr)
        {
            nl = new Node1;
            nl->nl = nl->nr = nullptr;
            nl->v = 0;
        }
        if (nr == nullptr)
        {
            nr = new Node1;
            nr->nl = nl->nr = nullptr;
            nr->v = 0;
        }
        if (p < m)
            nl->set(p, p1, x, cl, m);
        else
            nr->set(p, p1, x, m, cr);
        v->set(p1, gcd2(getGCD2(nl->v, p1, p1 + 1), getGCD2(nr->v, p1, p1 + 1)));
    }
};

ll getGCD1(Node1 * n, int l, int r, int l2, int r2, int cl = 0, int cr = 1 << 30)
{
    if (n == nullptr || r <= cl || cr <= l)
        return 0;
    if (l <= cl && cr <= r)
        return getGCD2(n->v, l2, r2);
    int m=  (cl + cr) >> 1;
    return gcd2(getGCD1(n->nl, l, r, l2, r2, cl, m), getGCD1(n->nr, l, r, l2, r2, m, cr));
}

Node1 * root;

void init(int r, int c)
{
    root = new Node1;
    root->nl = root->nr = nullptr;
    root->v = nullptr;
}

void update(int x, int y, long long t)
{
    root->set(x, y, t);
}

long long calculate(int xl, int yl, int xr, int yr)
{
    return getGCD1(root, xl, xr + 1, yl, yr + 1);
}
