#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

const int N = 1000111;
const int INF = 0x3f3f3f3f;

struct Vertex
{
	int next;
	long long len;
	int snmn;
	long long maxd, maxdp, maxd1;
	bool sorted;
	int com;
} v[N];

int getRoot(int a)
{
	int r = a;
	while (v[r].snmn != -1)
		r = v[r].snmn;
	while (a != r)
	{
		int next = v[a].snmn;
		v[a].snmn = r;
		a = next;
	}
	return r;
}

void merge(int a1, int a2)
{
	if (rand() % 2)
		v[getRoot(a1)].snmn = getRoot(a2);
	else
		v[getRoot(a2)].snmn = getRoot(a1);
}

bool check(int a1, int a2)
{
	return getRoot(a1) == getRoot(a2);
}
int n;


std::vector < long long > loops[N];
int lc = 0;
std::vector < int > topsort;
long long rez[N];
long long s[N], sn;

int nn, nni;
long long getS(int i)
{
	if (i < nn)
		return s[i];
	return sn + s[i-nn];
}
long long sq(int i)
{
	return v[loops[nni][i%nn]].maxd - getS(i);
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%lld", &v[i].next, &v[i].len);
		--v[i].next;
		v[i].snmn = -1;
	}
	for (int i = 0; i < n; ++i)
	{
		if (check(i, v[i].next))
		{
			int curr = i;
			do {
				loops[lc].push_back(curr);
				v[curr].com = lc;
				int nx = v[curr].next;
				v[curr].next = -1;
				curr = nx;
			} while (i != curr);
			++lc;
		} else
			merge(i, v[i].next);
	}
	for (int i = 0; i < n; ++i)
		if (!v[i].sorted)
		{
			int now = topsort.size();
			for (int c = i; c != -1 && !v[c].sorted; c = v[c].next)
			{
				topsort.push_back(c);
				v[c].sorted = true;
			}
			std::reverse(topsort.begin() + now, topsort.end());
			for (int j = now; j < topsort.size(); ++j)
				if (v[topsort[j]].next != -1)
					v[topsort[j]].com = v[v[topsort[j]].next].com;
		}
	for (int i = 0; i < n; ++i)
	{
		int c = topsort[n-i-1];
		int nx = v[c].next;
		if (nx != -1 && v[nx].maxd < v[c].maxd + v[c].len)
		{
			v[nx].maxdp = c;
			v[nx].maxd = v[c].maxd + v[c].len;
		}
	}
	for (int i = 0; i < n; ++i)
	{
		int c = topsort[n-i-1];
		int nx = v[c].next;
		if (nx != -1 && c != v[nx].maxdp && v[nx].maxd1 < v[c].maxd + v[c].len)
			v[nx].maxd1 = v[c].maxd + v[c].len;
		rez[v[c].com] = std::max(rez[v[c].com], v[c].maxd + v[c].maxd1);
	}
	
	for (int i = 0; i < lc; ++i)
	{
		nni = i;
		nn = loops[i].size();
		if (nn == 1)
			continue;
		s[0] = 0;
		for (int j = 1; j < nn; ++j)
			s[j] = s[j-1] + v[loops[i][j-1]].len;
		sn = s[nn-1] + v[loops[i][nn-1]].len;
		std::map < long long , int > maxx;
		++maxx[sq(0)];
		//for (int j = 0; j < nn*2; ++j)
		//	std::cerr << v[loops[i][j%nn]].maxd << " ";
		//std::cerr << "\n";
		//for (int j = 0; j < nn*2; ++j)
		//	std::cerr << s[j] << " ";
		//std::cerr << "\n";
		for (int j = 1; j < nn*2; ++j)
		{
			rez[i] = std::max(rez[i], getS(j) + v[loops[i][j%nn]].maxd + maxx.rbegin()->first);
			++maxx[sq(j)];
			if (j >= nn-1)
			{
				auto it = maxx.find(sq(j-nn+1));
				--it->second;
				if (it->second == 0)
					maxx.erase(it);
			}
			
		}
		//std::cerr << "-----------------------------------\n";
	}
	
	long long rr = 0;
	for (int i = 0; i < lc; ++i)
		rr += rez[i];
	std::cout << rr;
	return 0;
}
