#include <iostream>

using namespace std;

long long ans[51][51][51][51];
long long sum[51][51];

const long long INF = 1e18;

long long gets(int x1, int y1, int x2, int y2){
    if (x1 == 0){
        if (y1 == 0){
            return sum[x2 - 1][y2 - 1];
        }
        return sum[x2 - 1][y2 - 1] - sum[x2 - 1][y1 - 1];
    }
    if (y1 == 0){
        return sum[x2 - 1][y2 - 1] - sum[x1 - 1][y2 - 1];
    }
    return sum[x2 - 1][y2 - 1] - sum[x2 - 1][y1 - 1] - sum[x1 - 1][y2 - 1] + sum[x1 - 1][y1 - 1];
}

long long get(int x1, int y1, int x2, int y2){
    if (ans[x1][y1][x2][y2] != -1){
        return ans[x1][y1][x2][y2];
    }
    if (x1 == x2 - 1 && y1 == y2 - 1){
        ans[x1][y1][x2][y2] = 0;
        return 0;
    }
    long long mn = INF;
    for (int xm = x1 + 1; xm < x2; xm++){
        mn = min(mn, get(x1, y1, xm, y2) + get(xm, y1, x2, y2));
    }
    for (int ym = y1 + 1; ym < y2; ym++){
        mn = min(mn, get(x1, y1, x2, ym) + get(x1, ym, x2, y2));
    }
    mn += gets(x1, y1, x2, y2);
    ans[x1][y1][x2][y2] = mn;
    return ans[x1][y1][x2][y2];
}

int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            for (int l = i + 1; l <= n; l++){
                for (int r = j + 1; r <= m; r++){
                    ans[i][j][l][r] = -1;
                }
            }
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> sum[i][j];
        }
    }
    for (int i = 1; i < n; i++){
        sum[i][0] += sum[i - 1][0];
    }
    for (int i = 1; i < m; i++){
        sum[0][i] += sum[0][i - 1];
    }
    for (int i = 1; i < n; i++){
        for (int j = 1; j < m; j++){
            sum[i][j] += sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1];
        }
    }
    cout << get(0, 0, n, m);
    return 0;
}
