#include <iostream>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <algorithm>

const int N = 222;
const int M = 6666;

struct Edge
{
	int a, b, c;
	bool operator < (const Edge & e) const
	{
		return c < e.c;
	}
} e[M];

int n, w;

int dsu[N];

void dsuInit()
{
	memset(dsu, -1, n * sizeof(int));
}

int dsuRoot(int a)
{
	int r = a;
	while (dsu[r] != -1)
		r = dsu[r];
	while (a != r)
	{
		int na = dsu[a];
		dsu[a] = r;
		a = na;
	}
	return a;
}

int dsuCheck(int a, int b)
{
	return dsuRoot(a) == dsuRoot(b);
}

void dsuMerge(int a, int b)
{
	a = dsuRoot(a);
	b = dsuRoot(b);
	if (rand() & 1)
		std::swap(a, b);
	dsu[a] = b;
}

int main()
{
	srand(time(nullptr));
	std::cin >> n >> w;
	for (int i = 0; i < w; ++i)
	{
		Edge ne;
		std::cin >> ne.a >> ne.b >> ne.c;
		--ne.a;
		--ne.b;
		int p = std::lower_bound(e, e + i, ne) - e;
		for (int j = i - 1; j >= p; --j)
			e[j + 1] = e[j];
		e[p] = ne;

		int answer = 0, count = 0;
		dsuInit();
		for (int j = 0; j <= i; ++j)
		{
			if (dsuCheck(e[j].a, e[j].b))
				continue;
			dsuMerge(e[j].a, e[j].b);
			++count;
			answer += e[j].c;
		}
		if (count == n - 1)
			std::cout << answer << "\n";
		else
			std::cout << "-1\n";
	}
	return 0;
}