#include <iostream>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <unordered_set>
#include "grader.h"

typedef long long lint;

const int N = 100500;
const int K = 1005005;
const lint MOD = 1000000009;

int valid(int n, int inputSeq[])
{
	static bool was[K];
	int p1 = -1;
	for (int i = 0; i < n; ++i)
	{
		if (was[inputSeq[i]])
			return 0;
		was[inputSeq[i]] = 1;
		if (inputSeq[i] <= n)
		{
			int np1 = (n + i - inputSeq[i] + 1) % n;
			if (p1 == -1)
				p1 = np1;
			else if (p1 != np1)
				return 0;
		}
	}
	return 1;
}

int replacement(int n, int inputSeq[], int replacementSeq[])
{
	int p1 = 0;
	std::vector < int > bg;
	for (int i = 0; i < n; ++i)
		if (inputSeq[i] <= n)
			p1 = (n + i - inputSeq[i] + 1) % n;
		else
			bg.push_back(i);
	
	std::sort(bg.begin(), bg.end(), [inputSeq](int a, int b) { return inputSeq[a] < inputSeq[b]; });
	int rc = 0;
	int cm = n + 1;
	for (int i = 0; i < (int)bg.size(); ++i)
	{
		int p = bg[i];
		int s = (n + p - p1) % n + 1;
		replacementSeq[rc++] = s;
		for (int j = cm; j < inputSeq[p]; ++j)
			replacementSeq[rc++] = j;
		cm = inputSeq[p] + 1;
	}
	return rc;
	
}

lint pw(lint a, lint b)
{
	lint x = 1, aa = a;
	while (b != 0)
	{
		if (b & 1)
			(x *= aa) %= MOD;
		(aa *= aa) %= MOD;
		b >>= 1;
	}
	return x;
}

int countReplacement(int n, int inputSeq[])
{
	std::unordered_set < lint > was;
	std::vector < lint >  bg;
	lint p1 = -1;
	for (lint i = 0; i < n; ++i)
	{
		if (was.find(inputSeq[i]) != was.end())
			return 0;
		was.insert(inputSeq[i]);
		if (inputSeq[i] <= n)
		{
			lint np1 = (n + i - inputSeq[i] + 1) % n;
			if (p1 == -1)
				p1 = np1;
			else if (p1 != np1)
				return 0;
		} else
			bg.push_back(inputSeq[i]);
	}
	
	lint answer = 1;
	std::sort(bg.begin(), bg.end());
	lint pr = n;
	for (lint i = 0; i < (lint)bg.size(); ++i)
	{
		(answer *= pw(bg.size() - i, bg[i] - pr - 1)) %= MOD;
		pr = bg[i];
	}
	if (p1 == -1)
		(answer *= n) %= MOD;
	return (int)answer;
}