#include <iostream>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <unordered_set>
#include <cstring>
#include "grader.h"

const int N = 1555;

int pred[N], hgh[N], ts[N];
int ost[N], ostp[N], oc, dcount[N][N];

int getRoot(int a)
{
	int r = a;
	while (pred[r] != -1)
		r = pred[r];
	while (a != r)
	{
		int na = pred[a];
		pred[a] = r;
		a = na;
	}
	return a;
}

int merge(int a, int b)
{
	a = getRoot(a);
	b = getRoot(b);
	if (hgh[a] < hgh[b])
	{
		pred[a] = b;
		ts[b] += ts[a];
		return b;
	} else
	{
		pred[b] = a;
		ts[a] += ts[b];
		if (hgh[a] < hgh[b])
			++hgh[a];
		return a;
	}
}

void initialize(int n)
{
	memset(pred, -1, n * sizeof(int));
	for (int i = 0; i < n; ++i)
	{
		hgh[i] = ts[i] = 1;
		ost[i] = ostp[i] = i;
	}
	oc = n;
}

int hasEdge(int a, int b)
{
	int ra = getRoot(a), rb = getRoot(b);
	if (dcount[ra][rb] == ts[ra] * ts[rb] - 1)
	{
		int ca = merge(ra, rb);
		int cb = ((ca == ra) ? rb : ra);
		ost[ostp[cb]] = ost[--oc];
		ostp[ost[ostp[cb]]] = ostp[cb];
		for (int i = 0; i < oc; ++i)
		{
			int c = ost[i];
			if (c == ca)
				continue;
			dcount[c][ca] = dcount[ca][c] = dcount[ca][c] + dcount[cb][c];
		}
		return 1;
	} else {
		++dcount[ra][rb]; ++dcount[rb][ra];
		return 0;
	}
}