#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include "grader.h"

using namespace std;

const int MAXN = 150001;
const int INF = 1000 * 1000;
vector <int > e[MAXN];
int f[MAXN][2], cycle;
int f1[MAXN], c1;
int f2[MAXN], c2;
int n, m , p;
int q[MAXN * 2];
int qb, qe;
int sti1, sti2;

void tr(int x, int nx, int md)
{
	if ((e[x].size() > 2) && (e[x][0] != nx) && (e[x][1] != nx)) return;
	int tt = 0;
	if ((e[x].size() > 1) && (e[x][0] == nx)) tt = 1;
	if (f[x][tt] == INF)
	{
		f[x][tt] = md;
		q[qe++] = tt * n + x;
	}
	else
	{
		if ((x == sti1) && (tt == sti2) && (cycle == -1))
		{
			cycle = md;
		}
	}
}

void bfs(int si1, int si2)
{
	sti1 = si1, sti2 = si2;
	cycle = -1;
	qb = 0, qe = 1;
	for (int i = 0; i < n; i++)
	{
		f[i][0] = f[i][1] = INF;
	}
	f[si1][si2] = 0;
	q[0] = si2 * n + si1;
	while (qb < qe)
	{
		int v = q[qb] % n, tp = q[qb] / n;
		if (tp == 0)
		{
			tr(e[v][0], v, f[v][tp] + 1);
		}
		else
		{
			for (int i = 1; i < e[v].size(); i++)
			{
				tr(e[v][i], v, f[v][tp] + 1);
			}
		}
		qb++;
	}
}

void count_routes(int N, int M, int P, int R[][2], int Q, int G[])
{
	n = N, m = M, p = P;
	for (int i = 0; i < m; i++)
	{
		int v = R[i][0], u = R[i][1];
		e[v].push_back(u);
		e[u].push_back(v);
	}
	bfs(p, 0);
	for (int i = 0; i < n; i++)
	{
		if (e[i].size() > 1) f1[i] = f[i][1];
		else f1[i] = f[i][0];
	}
	c1 = cycle;
	if (c1 == -1) c1 = INF * 3;
	if (e[p].size() > 1)
	{
		bfs(p, 1);
		for (int i = 0; i < n; i++)
		{
			if (e[i].size() > 1) f2[i] = f[i][1];
			else f2[i] = f[i][0];
		}
		c2 = cycle;
		if (c2 == -1) c2 = 3 * INF;
	}
	for (int i = 0; i < Q; i++)
	{
		int k = G[i], res = 0;
		for (int j = 0; j < n; j++)
		{
			bool pos = false;
			if ((f1[j] <= k) && ((k - f1[j]) % c1 == 0) && (f1[j] != INF)) pos = true;
			if ((e[p].size() > 1) && (f2[j] != INF) && (f2[j] <= k) && ((k - f2[j]) % c2 == 0)) pos = true;
			if (pos) res++;
		}
		answer(res);
	}
}

