#include "grader.h"
#include <algorithm>

using namespace std;

int mn[6000001];
int mx[6000001];
bool f[6000001];

void push(int i){
    if (!f[i]) return;
    f[i] = false;
    mn[2 * i] = max(mn[2 * i], mn[i]);
    mx[2 * i] = max(mx[2 * i], mn[i]);
    mn[2 * i] = min(mn[2 * i], mx[i]);
    mx[2 * i] = min(mx[2 * i], mx[i]);
    mn[2 * i + 1] = max(mn[2 * i + 1], mn[i]);
    mx[2 * i + 1] = max(mx[2 * i + 1], mn[i]);
    mn[2 * i + 1] = min(mn[2 * i + 1], mx[i]);
    mx[2 * i + 1] = min(mx[2 * i + 1], mx[i]);
    f[2 * i] = f[2 * i + 1] = true;
}

void refresh(int i){
    mn[i] = min(mn[2 * i], mn[2 * i + 1]);
    mx[i] = max(mx[2 * i], mx[2 * i + 1]);
}

void add(int h, int l, int r, int ql, int qr, int i){
    if (ql >= r || l >= qr)
        return;
    if (qr >= r && l >= ql){
        mn[i] = max(mn[i], h);
        mx[i] = max(mx[i], h);
        f[i] = true;
        return;
    }
    push(i);
    int m = (l + r) / 2;
    add(h, l, m, ql, qr, 2 * i);
    add(h, m, r, ql, qr, 2 * i + 1);
    refresh(i);
}

void del(int h, int l, int r, int ql, int qr, int i){
    if (ql >= r || l >= qr)
        return;
    if (qr >= r && l >= ql){
        mn[i] = min(mn[i], h);
        mx[i] = min(mx[i], h);
        f[i] = true;
        return;
    }
    push(i);
    int m = (l + r) / 2;
    del(h, l, m, ql, qr, 2 * i);
    del(h, m, r, ql, qr, 2 * i + 1);
    refresh(i);
}

int get(int pos, int l, int r, int i){
    if (l == r - 1){
        return mn[i];
    }
    push(i);
    int m = (l + r) / 2;
    if (m > pos){
        return get(pos, l, m, 2 * i);
    }
    else{
        return get(pos, m, r, 2 * i + 1);
    }
}

void buildWall(int n, int k, int op[], int left[], int right[], int height[], int finalHeight[]){
    for (int i = 0; i < k; i++){
        if (op[i] == 1){
            add(height[i], 0, n, left[i], right[i] + 1, 1);
        }
        else{
            del(height[i], 0, n, left[i], right[i] + 1, 1);
        }
    }
    for (int i = 0; i < n; i++){
        finalHeight[i] = get(i, 0, n, 1);
    }
}

