#include "grader.h"
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

long long a[3000001];
map<int, bool> used;
int pr[3000001];
const long long MOD = 1e9 + 9;

long long mult(long long a, long long b){
    return (a * b) % MOD;
}

long long st(long long a, long long b){
    long long s = a;
    long long ans = 1;
    while (b > 0){
        if (b & 1){
            ans = mult(ans, s);
        }
        b = b >> 1;
        s = mult(s, s);
    }
    return ans;
}

long long div (long long a, long long b){
    return mult(a, st(b, MOD - 2));
}

long long fact(int n){
    long long ans = 1;
    for (int i = 2; i <= n; i++){
        ans = mult(ans, (long long) i);
    }
    return ans;
}

long long cnt(long long a, long long b){
    return st(b, a - b);
}

int valid(int n, int inputSeq[]){
    int k = -1;
    for (int i = 0; i < n; i++){
        if (inputSeq[i] <= n){
            k = i;
            break;
        }
    }
    if (k == -1){
        for (int i = 1; i <= n; i++){
            a[i] = inputSeq[i - 1];
        }
    }
    else{
        int r = inputSeq[k];
        for (int i = 0; i < n; i++){
            a[i + 1] = inputSeq[(i + 1 + k - r + n) % n];
        }
    }
    for (int i = 1; i <= n; i++){
        if ((a[i] <= n && a[i] != i) || used[a[i]]){
            return 0;
        }
        used[a[i]] = true;
    }
    return 1;
}

int replacement(int n, int gondolaSeq[], int replacementSeq[]){
    int k = -1;
    for (int i = 0; i < n; i++){
        if (gondolaSeq[i] <= n){
            k = i;
            break;
        }
    }
    if (k == -1){
        for (int i = 1; i <= n; i++){
            a[i] = gondolaSeq[i - 1];
        }
    }
    else{
        int r = gondolaSeq[k];
        for (int i = 0; i < n; i++){
            a[i + 1] = gondolaSeq[(i + 1 + k - r + n) % n];
        }
    }
    int mx = n;
    for (int i = 1; i <= n; i++){
        if (a[i] != i)
            pr[a[i] - n] = i;
        if (a[i] > mx)
            mx = a[i];
    }
    int an = mx - n;
    if (an == 0) return 0;
    int cur = pr[an];
    pr[an] = 0;
    for (int i = 1; i <= an; i++){
        if (pr[i] == 0){
            pr[i] = cur;
            cur = n + i;
        }
    }
    for (int i = 0; i < an; i++){
        replacementSeq[i] = pr[i + 1];
    }
    return an;
}

int countReplacement(int n, int inputSeq[]){
    int b = valid(n, inputSeq);
    if (!b) return 0;
    int k = -1;
    for (int i = 0; i < n; i++){
        if (inputSeq[i] <= n){
            k = i;
            break;
        }
    }
    if (k == -1){
        for (int i = 1; i <= n; i++){
            a[i] = inputSeq[i - 1];
        }
    }
    else{
        int r = inputSeq[k];
        for (int i = 0; i < n; i++){
            a[i + 1] = inputSeq[(i + 1 + k - r + n) % n];
        }
    }
    int mx = n;
    vector<int> v;
    for (int i = 1; i <= n; i++){
        if (a[i] != i)
            v.push_back(a[i]);
        if (a[i] > mx)
            mx = a[i];
    }
    sort(v.begin(), v.end());
    long long last = n + 1;
    long long ans = 1;
    for (int i = 0; i < v.size(); i++){
        ans = mult(ans, st((v.size() - i), v[i] - last));
        last = v[i] + 1;
    }
    if (k == -1) ans = mult(ans, n);
    return ans;
}