#include "grader.h"  
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int n;

const int MAXN = 1000001;
int p[MAXN], rnk[MAXN];
bool ck[MAXN];
int cn[MAXN];
int mv[MAXN], ver = 0, ans;
vector <int> e[MAXN];

void dfs(int v, int p1, int p2)
{
	if (p2 != -1)
	{
		p[v] = v;
	}
	else
	{
		p[v] = p1;
	}
	for (int i = 0; i < e[v].size(); i++)
	{
		if (e[v][i] == p1) continue;
		if (e[v][i] == p2) continue;
		
		dfs(e[v][i], v, -1);
	}
}

vector <int> tekpath, cycle;

int fin;

void dfs2(int v, int p)
{
	tekpath.push_back(v);
	if (v == fin)
	{
		cycle = tekpath;
	}
	for (int i = 0; i < e[v].size(); i++)
	{
		if (e[v][i] == p) continue;
		dfs2(e[v][i], v);
	}
	tekpath.pop_back();
}

void uni(int a, int b, int nf = 0)
{
	if (rnk[a] == rnk[b]) rnk[a]++;
	if (rnk[a] > rnk[b]) swap(a, b);
	p[a] = b;
}

int fnd(int a)
{
	int x = a;
	while (p[x] != x) x = p[x];
	while (p[a] != x)
	{
		int c2 = a;
		a = p[a];
		p[c2] = x;
	}
	return x;
}

void Init(int N_) {

  n = N_;
  for (int i = 0; i < n; i++)
  {
	  mv[i] = rnk[i] = 0;
	  ck[i] = false;
	  p[i] = i;
  }
  ans = n;
}

bool cycled = false;


void lnk1(int a, int b)
{
	int va = fnd(a), vb = fnd(b);
	if (va == vb)
	{
		fin = b;
		dfs2(a, a);
		cycled = true;
		int cs = cycle.size();
		ans = 0;
		for (int i = 0; i < cycle.size(); i++)
		{
			cn[i] = 0;
			ck[i] = true;
			if (mv[cycle[i]] == ver) ans++, mv[cycle[i]]++;
		}
		ver++;
		e[a].push_back(b);
		e[b].push_back(a);
		for (int i = 0; i < cycle.size(); i++)
		{
			dfs(cycle[i], cycle[(i + 1) % cs], cycle[(i + cs - 1) % cs]);
		}
	}
	else
	{
		uni(va, vb);
		e[a].push_back(b);
		e[b].push_back(a);
	}
}

void lnk2(int a, int b)
{
	int va = fnd(a), vb = fnd(b);
	if (ck[va] && !ck[vb])
	{
		swap(a, b);
		swap(va, vb);
	}
	if (!ck[va])
	{
		if (va == vb) ver++;
		else
		{
			if (ck[vb])
			{
				p[va] = vb;
			}
			else
			{
				uni(va, vb);
			}
		}
	}
	else if (va != vb)
	{
		if (va != a) cn[va]++;
		if (vb != b) cn[vb]++;
		ans = 0;
		if ((mv[va] == ver) && (cn[va] < 2)) ans++, mv[va]++;
		if ((mv[vb] == ver) && (cn[vb] < 2)) ans++, mv[vb]++;
		ver++;
	}
	else
	{
		ans = 0;
		if (((a == va) || (b == va)) && (mv[va] == ver)) ans++, mv[va]++;
		ver++;
	}
	e[a].push_back(b);
	e[b].push_back(a);
}

void Link(int A, int B)
{
	if (cycled) lnk2(A, B);
	else lnk1(A, B);
	if (e[A].size() > 3)
	{
		ans = 0;
		if (mv[A] == ver) ans++, mv[A]++;
		ver++;
	}
	if (e[B].size() > 3)
	{
		ans = 0;
		if (mv[B] == ver) ans++, mv[B]++;
		ver++;
	}
	if (e[A].size() == 3)
	{
		ans = 0;
		if (mv[A] == ver) ans++, mv[A]++;
		for (int i = 0; i < 3; i++)
		{
			if (mv[e[A][i]] == ver) ans++, mv[e[A][i]]++;
		}
		ver++;
	}
	if (e[B].size() == 3)
	{
		ans = 0;
		if (mv[B] == ver) ans++, mv[B]++;
		for (int i = 0; i < 3; i++)
		{
			if (mv[e[B][i]] == ver) ans++, mv[e[B][i]]++;
		}
		ver++;
	}
}


int CountCritical() {
	return ans;
}
