#include <cstdio>
#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

struct edge{
    int a, b;
    long long w;

    edge(){
    }

    edge(int _a, int _b, long long _w){
        a = _a;
        b = _b;
        w = _w;
    }
};

int p[201];
int h[201];

bool operator < (edge a, edge b){
    return a.w < b.w;
}

vector<edge> edges;

int get(int a){
    if (a != p[a]) p[a] = get(p[a]);
    return p[a];
}

int n;
int ct;
long long sum;

void unite(int a, int b, long long w){
    a = get(a);
    b = get(b);
    if (a == b) return;
    ct--;
    sum += w;
    if (h[a] > h[b]){
        p[b] = a;
        return;
    }
    if (h[a] == h[b]) h[b]++;
    p[a] = b;
}

long long get(){
    sort(edges.begin(), edges.end());
    for (int i = 1; i <= n; i++){
        p[i] = i;
        h[i] = 0;
    }
    ct = n;
    sum = 0;
    for (auto p: edges){
        unite(p.a, p.b, p.w);
    }
    if (ct != 1) return -1;
    return sum;
}

int main()
{
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int a, b;
        long long w;
        scanf("%d%d%I64d", &a, &b, &w);
        edges.push_back(edge(a, b, w));
        printf("%I64d\n", get());
        fflush(stdout);
    }
    return 0;
}
